﻿var lastClickTime = (new Date()).valueOf();

function isFastClick() {
    var currentTime = (new Date()).valueOf();
    console.log("c_" + currentTime + "|" + "l_" + lastClickTime);
    if (currentTime - lastClickTime < 500) {
        return true;
    }
    lastClickTime = currentTime;
    return false;
}

// 2019-5-5 15:13:42 手机号正则表达式
var regPhoneNum = /^1[3-9][0-9]{9}$/;

var vpRelation = ['', '本人', '父母', '子女', '配偶', '亲戚', '', '', '', '其他'];

// 2017-01-09 14:52:51 上传通知权限
// 2017-4-20 09:36:29 仅iOS调用 防止Android报传入参数错误
function SetNoticeAuth() {
    if (currentPlatform == "iOS") {
        console.log("SetNoticeAuth: accountId=" + localStorage.currentAccountId + "; noticeAuth=" + localStorage.noticeAuth);
        if (localStorage.currentAccountId != null && localStorage.currentAccountId.length != 0) {
            console.log('TODO: AJAX: ' + "noticeAuth=" + localStorage.noticeAuth + "&a=" + localStorage.currentAccountId + "&p=" + currentPlatform + "&t=" + deviceToken + '&v=' + currentAppVersion);
            $.ajax({
                type: "POST",
                timeout: 3000,
                url: serviceUrl + "/Account/SetNoticeAuth?noticeAuth=" + localStorage.noticeAuth,
                data: { noticeAuth: localStorage.noticeAuth },
                dataType: "JSON",
                xhrFields: {
                    withCredentials: true
                },
                crossDomain: true,
                contentType: "applicaion/json",
                beforeSend: function (request) {
                    request.setRequestHeader("FW-Account-Id", localStorage.currentAccountId);
                    request.setRequestHeader("FW-Device-Platform", currentPlatform);
                    request.setRequestHeader("FW-Push-Token", deviceToken);
                    request.setRequestHeader("FW-App-Version", currentAppVersion);
                    request.setRequestHeader("FW-Xhr-Timestamps", Date.parse(new Date()));
                    request.setRequestHeader("FW-Xhr-Token", calcToken(request));
                },
                success: function (data) {
                    if (data.result == 1) {
                        console.log("上传通知权限成功");
                    }
                    else {
                        console.log(data.msg);
                    }
                }
            });
        }
    }
}

// 显示APP内浏览器
function showInAppBrowser(url, target, options) {
    console.log(url);
    cordova.InAppBrowser.open(url, target, options);
}

// 计算token
function calcToken(config) {
    var param = new Object();
    var paraName = new Array();

    if (config.data != null) {
        for (var i in config.data) {
            param[i.toLowerCase()] = config.data[i];
            paraName.push(i.toLowerCase());
        }
    }

    if (config.headers != null) {
        for (var i in config.headers) {
            //console.log(i);
            if (i.indexOf("FW-") > -1) {
                param[i.toLowerCase()] = config.headers[i];
                paraName.push(i.toLowerCase());
            }
        }
    }
    paraName.sort();
    //console.log(param);
    var strOri = '';
    for (var i in paraName) {
        strOri += paraName[i] + "=" + param[paraName[i]] + "&";
    }

    if (strOri.length > 0) {
        strOri = strOri.substr(0, strOri.length - 1);
    }

    return md5(strOri);
}

// 获取QueryString数值
function getQueryVariable(queryString, variable) {
    if (queryString == null) {
        queryString = window.location.search.substring(1);
    }
    var vars = queryString.split('&');
    for (var i = 0; i < vars.length; i++) {
        var pair = vars[i].split('=');
        if (decodeURIComponent(pair[0]) == variable) {
            return decodeURIComponent(pair[1]);
        }
    }
    return null;
}

// 计算密码强度
function calcPwdLevel(pwd) {
    var strongRegex = new RegExp("^(?=.{8,})(?=.*[A-Z])(?=.*[a-z])(?=.*[0-9]).*$", "g");
    // 2020-3-13 18:03:48 中档强度要求由7位改为8位
    var mediumRegex = new RegExp("^(?=.{8,})(((?=.*[A-Z])(?=.*[a-z]))|((?=.*[A-Z])(?=.*[0-9]))|((?=.*[a-z])(?=.*[0-9]))).*$", "g");
    var enoughRegex = new RegExp("(?=.{6,}).*", "g");
    if (!enoughRegex.test(pwd)) {
        return 0;
    }
    else if (strongRegex.test(pwd)) {
        return 3;
    }
    else if (mediumRegex.test(pwd)) {
        return 2;
    }
    else {
        return 1;
    }
}

// 2019-5-26 17:08:01 jsencrypt.js RSA非对称加密解密
var jsencrypt = new JSEncrypt();
var pubkey = 'MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCgUdCgBg+glqg4Wwq8WgZvggYM+kpeBawWxh7xhJs1c5Lwrah5X3u49yaqoodnjxo2xRBGOCdM53aWmi7hUJ6zvgxsWmFMH+OgrWgg7TEWMCQiMzyu/OjtVGrE4djn2WfXPhkO53kNZsDH0IkKwIFYy9AJEXsh0oospyUZiI02EQIDAQAB';
jsencrypt.setPublicKey(pubkey);
