﻿angular.module('fwapp.controllers')

// 检查预约
.controller('CheckApptController', function ($scope, $rootScope, $state, $stateParams, $timeout, $fwCordovaToast, RequestService, PersonalService
    , $ionicModal, $ionicPopup, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet, dateFilter) {
    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }
    // 检查预约列表
    $scope.checkApptList = [];
    // 获取检查预约状态
    $scope.isLoading = false;
    // 检查预约序列
    $scope.checkApptIndex = 0;
    // 检查可改约日期数据
    $scope.apptSchedDate = [];
    // 检查预约日期 给控件用的
    $scope.apptDate = {};
    $scope.apptDate.target = "";
    $scope.apptDate.targetOri = "";
    $scope.apptDate.dateMode = "white";
    $scope.apptDate.dateList = [];
    $scope.apptDate.minDate = "1970-01-01";
    $scope.apptDate.maxDate = "1970-01-01";
    // 缓存
    $scope.apptDate.targetCache = "";
    // 改期时段
    $scope.apptDate.targetTime = "";
    $scope.apptDate.targetTimeOri = "";
    // 改期时段ID
    $scope.apptDate.timeAreaId = "";
    // 是否正在改期
    $scope.isChangingDate = false;
    // 打哪儿来
    $scope.from = $stateParams.from;

    // 2022-1-19 10:11:14 HM #49853 检查预约改约bug，index有问题，这里记录检查单号
    $scope.CHECK_APPT_ID = "";

    // 注册模态窗口：检查预约详情
    $ionicModal.fromTemplateUrl('checkApptDetail.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.checkApptDetailModal = modal;
    });

    // 注册模态窗口：预约改期
    $ionicModal.fromTemplateUrl('changeApptDate.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.changeApptDateModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.checkApptDetailModal.remove();
        $scope.changeApptDateModal.remove();
    })

    // 预约详情模态窗口显示
    $scope.checkApptDetailShow = function (index) {
        $scope.checkApptIndex = index;

        // 初次赋值
        $scope.CHECK_APPT_ID = $scope.checkApptList[index].CHECK_APPT_ID;

        $scope.checkApptDetailModal.show();
        $ionicScrollDelegate.$getByHandle('checkAppt').scrollTop();
    }
    // 预约详情模态窗口隐藏
    $scope.checkApptDetailHide = function () {
        $scope.checkApptDetailModal.hide();
        $scope.checkApptIndex = 0;
    }
    // 获取检查预约列表
    $scope.getCheckApptList = function (isChangeSched) {
        $ionicLoading.show();
        $scope.isLoading = true;
        RequestService.checkApptList().then(function (data) {
            //console.log(JSON.stringify(data));
            // 若直接缓存结果
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING（假装我有很认真的查询）
                $timeout(function () {
                    // 无记录处理
                    if (data.is_null == 1) {
                        $scope.loadResult = 3;
                    } else {
                        // 有记录
                        $scope.loadResult = 0;
                        $scope.checkApptList = data.data;
                    }
                    $ionicLoading.hide();
                    $scope.isLoading = false;
                }, 1000);
                return;
            }
            // 非缓存处理 隐藏LOADING页面
            $ionicLoading.hide();
            $scope.isLoading = false;
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.getCheckApptList();
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $scope.loadResult = 3;
                return;
            }
            // 后边遍历获取条形码 可能耗时较长
            $ionicLoading.show();
            // 格式化数据
            for (var i in data.data) {
                // 检查日期
                if (data.data[i].hasOwnProperty("ORDER_DATE") && data.data[i]["ORDER_DATE"] != null && data.data[i]["ORDER_DATE"].length > 0) {
                    data.data[i]["ORDER_DATE_FORMAT"] = new Date(data.data[i]["ORDER_DATE"]).Format("yyyy年M月d日");
                }
                // 注意事项
                if (data.data[i].hasOwnProperty("PRECAUTIONS") && data.data[i]["PRECAUTIONS"] != null && data.data[i]["PRECAUTIONS"].length > 0) {
                    data.data[i]["PRECAUTIONS_FORMAT"] = data.data[i]["PRECAUTIONS"].split("|  ").join("").split("|");
                }
                // 温馨提示
                if (data.data[i].hasOwnProperty("TIPS") && data.data[i]["TIPS"] != null && data.data[i]["TIPS"].length > 0) {
                    data.data[i]["TIPS_FORMAT"] = data.data[i]["TIPS"].split("|").join("").split("|");
                }
                // 2019-9-5 09:53:01 由于iOS审核被拒 检查号序着急上线 暂时拼在了检查时间后边 老版本直接显示 新版本需判断截断字符串
                if (data.data[i].hasOwnProperty("ORDER_TIME") && data.data[i]["ORDER_TIME"] != null && data.data[i]["ORDER_TIME"].length > 0
                    && data.data[i]["ORDER_TIME"].indexOf("   ") > -1 && $scope.formatOrderNum(data.data[i]["ORDER_NUM"]) > 0) {
                    data.data[i]["ORDER_TIME"] = data.data[i]["ORDER_TIME"].substr(0, data.data[i]["ORDER_TIME"].indexOf("   "));
                }

                // 2022-1-19 10:33:21 HM 如果是改约，查一下checkAppid
                if (isChangeSched && $scope.CHECK_APPT_ID == data.data[i]["CHECK_APPT_ID"]) {
                    $scope.CHECK_APPT_ID = data.data[i]["CHECK_APPT_ID"];
                    $scope.checkApptIndex = i;
                }
            }
            // 卡号条形码列表
            var barcodeList = [];
            var ajaxCount = 0;
            // 假`就诊卡号列表
            var hisCardNumList = new Set(data.data.map(e => e["PATIENT_ID"]));
            console.log(hisCardNumList);
            hisCardNumList.forEach(hisCardNum => {
                ajaxCount++;
                PersonalService.getCardCodeBarcode("", hisCardNum).then(function (dataBarcode) {
                    // 获取成功
                    if (dataBarcode.result == 1) {
                        // 把条形码赋值给预约单
                        for (var i in data.data) {
                            if (data.data[i]["PATIENT_ID"] == hisCardNum) {
                                data.data[i]["BARCODE_SRC"] = "data:image/jpeg;base64," + dataBarcode.data;
                            }
                        }
                    }
                    // 获取失败
                    else {
                        ;
                    }
                    ajaxCount--;
                    // 已全部返回
                    if (ajaxCount == 0) {
                        $ionicLoading.hide();
                    }

                }, function (dataBarcode) {
                    ajaxCount--;
                    // 已全部返回
                    if (ajaxCount == 0) {
                        $ionicLoading.hide();
                    }
                });
            });

            $scope.checkApptList = data.data;
            console.log($scope.checkApptList);
            // 改期回调
            if (isChangeSched) {
                // 隐藏改期窗口
                $scope.changeApptDateHide();
            }
        })
    }

    // 2019-8-29 17:06:46 由于Number()在页面调用返回false 提到function里
    $scope.formatOrderNum = function (strOrderNum) {
        if (!strOrderNum || strOrderNum.length == 0) {
            return 0;
        }
        var orderNum = Number(strOrderNum);
        return orderNum > 0 ? orderNum : 0;
    }

    // 返回按钮
    $scope.goBack = function () {
        if ($scope.from == "app.message") {
            $rootScope.goBack();
        }
        else {
            $state.go('app.home');
        }
    }

    // 获取检查预约列表
    $scope.getCheckItemSched = function () {
        // 不可改期
        if ($scope.checkApptList[$scope.checkApptIndex].MODIFY_STATUS != "1") {
            if ($scope.checkApptList[$scope.checkApptIndex].MODIFY_STATUS_REMARK != "") {
                $fwCordovaToast.showShortBottom($scope.checkApptList[$scope.checkApptIndex].MODIFY_STATUS_REMARK);
            }
            return;
        }
        $ionicLoading.show();
        RequestService.getCheckItemSched($scope.checkApptList[$scope.checkApptIndex].PATIENT_ID, $scope.checkApptList[$scope.checkApptIndex].MEDICIAL_ITEM_ID).then(function (data) {
            console.log(data);
            // 若直接缓存结果
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING（假装我有很认真的查询）
                $timeout(function () {
                    // 无记录处理
                    if (data.is_null == 1) {
                        ;
                    } else {
                        // 有记录
                        $scope.formatCheckItemSchedData(data.data);
                    }
                    $ionicLoading.hide();
                }, 1000);
                return;
            }
            // 非缓存处理 隐藏LOADING页面
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            $scope.formatCheckItemSchedData(data.data);
        })
    }

    // 格式化并赋值预约改期数据
    $scope.formatCheckItemSchedData = function (data) {
        // 格式化日期
        data.forEach(e => e["ORDER_DATE_FORMAT"] = new Date(e["ORDER_DATE"]).Format("yyyy-MM-dd"));
        // 先赋值 待选择日期后处理
        $scope.apptSchedDate = data;
        console.log($scope.apptSchedDate);
        // 可预约日期列表
        var dateList = new Set(data.map(e => e["ORDER_DATE_FORMAT"]));
        $scope.apptDate.dateList = Array.from(dateList).sort();
        if($scope.apptDate.dateList.length > 0) {
            $timeout(function () {
                $scope.apptDate.minDate = $scope.apptDate.dateList[0];
                $scope.apptDate.maxDate = $scope.apptDate.dateList[$scope.apptDate.dateList.length - 1];
                console.log($scope.apptDate.minDate + " - " + $scope.apptDate.maxDate);
            }, 0);
        }
        console.log($scope.apptDate.dateList);
        // 当前选择日期
        var dateTarget = $scope.checkApptList[$scope.checkApptIndex].ORDER_DATE;
        // 格式化
        if (dateTarget != null && dateTarget.length > 0) {
            dateTarget = new Date(dateTarget).Format("yyyy-MM-dd");
        }
        $scope.apptDate.target = dateTarget;
        // 深度制 脏检测
        $scope.apptDate.targetOri = dateTarget;
        // 时段
        $scope.apptDate.targetTime = $scope.checkApptList[$scope.checkApptIndex].ORDER_TIME;
        $scope.apptDate.targetTimeOri = $scope.checkApptList[$scope.checkApptIndex].ORDER_TIME;
        // 预约改期模态窗口显示
        $scope.changeApptDateShow();
    }
    // 弹出选择时段
    $scope.selectTimeShow = function () {
        console.log("改期: " + $scope.apptDate.targetOri + " => " + $scope.apptDate.target);
        // 过滤ActionSheet的数据源
        var arrTime = $scope.apptSchedDate.filter(e => e["ORDER_DATE_FORMAT"] == $scope.apptDate.target);
        // 遍历生成按钮
        var arrButton = [];
        arrTime.forEach(e => {
            var str = e["ORDER_TIME"];
            // 判断预约状态 加后缀和样式
            if (e["ORDER_STATUS"] == "0") {
                str += " (可预约)";
                str = '<span>' + str + '</span>';
            }
            else {
                str += " (已约满)";
                str = '<span class="fw-action-sheet-error">' + str + '</span>';
            }
            arrButton.push({ text: str });
        });
        console.log(arrButton);
        // 弹出透明loading防止快速连击关闭modal
        $ionicLoading.show({template: " "});
        // 确定标识
        var isOk = false;
        // 弹出ActionSheet
        var hideSheet = $ionicActionSheet.show({
            buttons: arrButton,
            titleText: "选择预约时段",
            cancelText: "取消",
            cancel: function () {
                // 未选择时段 回滚日期
                if (!isOk) {
                    // 读取缓存
                    if ($scope.apptDate.targetCache == "") {
                        $scope.apptDate.targetCache = $scope.apptDate.targetOri;
                    }
                    $scope.apptDate.target = $scope.apptDate.targetCache;
                }
                hideSheet();
                $timeout(function(){
                    $ionicLoading.hide();
                }, 200)
            },
            buttonClicked: function (index) {
                // 约满
                if (arrTime[index]["ORDER_STATUS"] == "1") {
                    return false;
                }
                console.log(arrTime[index]);
                $scope.apptDate.targetTime = arrTime[index]["ORDER_TIME"];
                $scope.apptDate.timeAreaId = arrTime[index]["TIME_AREA_ID"];
                // 写入缓存
                $scope.apptDate.targetCache = $scope.apptDate.target;
                isOk = true;
                hideSheet();
                $timeout(function(){
                    $ionicLoading.hide();
                }, 200)
            }
        });
    }
    // 预约改期模态窗口显示
    $scope.changeApptDateShow = function () {
        $scope.isChangingDate = true;
        $scope.apptDate.timeAreaId = "";
        $scope.apptDate.targetCache = "";
        $scope.changeApptDateModal.show();
        $ionicScrollDelegate.$getByHandle('changeApptDate').scrollTop();
    }
    // 检查预约改期提交
    $scope.checkApptUpdate = function () {
        // 提交改期申请
        $ionicLoading.show();
        console.log($scope.apptDate);
        RequestService.checkApptUpdate($scope.checkApptList[$scope.checkApptIndex].PATIENT_ID, $scope.checkApptList[$scope.checkApptIndex].CHECK_APPT_ID
            , $scope.apptDate.target, $scope.apptDate.timeAreaId).then(function (data) {
            console.log(data);
            // 若直接缓存结果
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING（假装我有很认真的查询）
                $timeout(function () {
                    // 无记录处理
                    if (data.is_null == 1) {
                        ;
                    } else {
                        console.log(data);
                        // 改期成功
                        if (data.data[0].UPDATE_RESULT == "True") {
                            // 重新获取检查预约列表
                            $scope.getCheckApptList(true);
                        }
                        // 失败
                        else {
                            // 2021-4-11 12:31:35 HM 改成popup的alert
                            $ionicPopup.alert({
                                title: '提示',
                                template: data.data[0].ERROR_MSG,
                                okText: "确定"
                            });
                        }
                    }
                    $ionicLoading.hide();
                }, 1000);
                return;
            }
            // 非缓存处理 隐藏LOADING页面
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                // 2021-4-11 12:31:35 HM 改成popup的alert
                $ionicPopup.alert({
                    title: '提示',
                    template: "连接超时，请重试",
                    okText: "确定"
                });
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                // 2021-4-11 12:31:35 HM 改成popup的alert
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            console.log(data);
            // 改期成功
            if (data.data[0].UPDATE_RESULT == "True") {
                // 重新获取检查预约列表
                $scope.getCheckApptList(true);
            }
            // 失败
            else {
                // 2021-4-11 12:31:35 HM 改成popup的alert
                $ionicPopup.alert({
                    title: '提示',
                    template: data.data[0].ERROR_MSG,
                    okText: "确定"
                });
            }
        })
    }
    // 预约改期模态窗口隐藏
    $scope.changeApptDateHide = function () {
        $scope.changeApptDateModal.hide();
        $scope.isChangingDate = false;
        $scope.apptDate.timeAreaId = "";
        $scope.apptDate.targetCache = "";
    }

    $scope.$on('$ionicView.enter', function () {
        // 获取检查预约列表
        $scope.getCheckApptList();
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'checkApptList');
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'checkApptList') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})
