﻿angular.module('fwapp.controllers')

.controller('flupSrvyController', function ($scope, $rootScope, $state, $stateParams, $timeout,
    VisitPatientService, flupSrvyService, SrvyService,
    $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicPopup, $ionicActionSheet, $ionicModal, $ionicPopover,
    $cordovaDatePicker, $fwCordovaToast) {

    // 专科随访滑动
    $scope.step = 0;
    var slideFlupList = $ionicSlideBoxDelegate.$getByHandle('slideFlupList');

    // 随访任务（患者）滑动
    var flupTaskList = $ionicSlideBoxDelegate.$getByHandle('flupTaskList');
    // 默认展示
    $scope.activeTask = 0;

    // 就诊人ID
    $scope.vpId = '';
    // 随访类型
    // $scope.srvyType = $stateParams.type;
    // 随访任务ID
    $scope.taskId = '';
    // 随访任务
    $scope.flupList = [];
    // 随访任务信息
    $scope.flupInfo = new Object();
    // 随访记录列表
    $scope.flupRecList = new Object();
    // 随访患者ID
    $scope.patientId = '';
    // 随访记录
    $scope.flupRecList = [];

    // 模板内容
    $scope.tmpl = new Object();
    // 模板信息
    $scope.tmplInfo = new Object();
    // 总题数
    $scope.qstnCount = 0;
    // 问卷结果
    $scope.srvyResult = new Object();
    // 当前问卷ID
    $scope.currentRec = new Object();
    // 反馈列表(评价)
    $scope.fbResultList = new Object();
    // 反馈列表(评分)
    $scope.fbCalcList = new Object();
    // 反馈TAB页
    $scope.feebbackTab = 0;

    // #region 模态框口
    // 注册模态窗口
    // 量表评估
    $ionicModal.fromTemplateUrl('templates/srvyTmpl.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.srvyModal = modal;
    });
    // 建议反馈
    $ionicModal.fromTemplateUrl('templates/feedback.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.feedbackModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.srvyModal.remove();
        $scope.feedbackModal.remove();
    })
    // #endregion

    // #region 滑动方法
    // 滑到上一步
    $scope.lastSlide = function () {
        slideFlupList.previous();
        $scope.step = slideFlupList.currentIndex();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideFlupList.next();
        $scope.step = slideFlupList.currentIndex();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideFlupList.slide(index);
        $scope.step = slideFlupList.currentIndex();
    }
    // 页面切换
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }
    // 随访任务-页面切换
    $scope.taskSlideChanged = function () {
        var taskIndex = flupTaskList.currentIndex();
        $scope.flupInfo = $scope.flupList[taskIndex];
        $scope.vpId = $scope.flupList[taskIndex].VISIT_PATIENT_ID; // APP患者ID
        $scope.patientId = $scope.flupList[taskIndex].PATIENT_ID; // 随访患者ID
        // 切换健康宣教
        $scope.changeArticleList();
        // 重新加载
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }
    // #endregion

    //#region 随访相关方法
    // 读取随访任务
    $scope.loadSrvyInfo = function () {
        $scope.flupList = [];
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        flupSrvyService.getFlupPatient().then(function (data) {
            if (data.result != 1) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                console.log(data.data);
                $scope.flupList = data.data;
                if (data.data.length > 0) {
                    if ($stateParams.vpId != '') {
                        for (var i = 0; i < data.data.length; i++) {
                            if (data.data[i].VISIT_PATIENT_ID == $stateParams.vpId) {
                                // $scope.activeTask = i;
                            }
                        }
                    }
                    // 展示随访患者信息
                    $scope.flupInfo = $scope.flupList[0];
                    $scope.vpId = $scope.flupList[0].VISIT_PATIENT_ID;
                    $scope.patientId = $scope.flupList[0].PATIENT_ID;
                    // 更新页面
                    flupTaskList.update();
                    slideFlupList.update();
                }
            }
            $scope.isLoadFinish = true;
            $ionicScrollDelegate.scrollTop();
            $ionicScrollDelegate.resize();
            $ionicLoading.hide();
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络连接异常，请重试");
        });
    }

    // 进入随访记录
    $scope.flupRecord = function (PATIENT_ID) {
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        flupSrvyService.srvyRecordList(PATIENT_ID).then(function (data) {
            if (data.result != 1) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                console.log(data.data);
                $scope.flupRecList = data.data;
            }
            $ionicLoading.hide();
        }, function () {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("网络连接异常，请重试");
        });
        $scope.isLoadFinish = true;
        $scope.toSlide(1);
    }

    // 填写问卷
    $scope.showTmpl = function (tmplId, taskId, recId) {
        if (tmplId.length < 1) {
            $fwCordovaToast.showShortBottom("暂无可随访的问卷");
        }
        $scope.taskId = taskId;
        $scope.currentRec = recId;
        $scope.loadTmpl(tmplId);
    }

    // 加载模板信息
    $scope.loadTmpl = function (tmplId) {
        $scope.isLoadFinish_Tmpl = false;
        $ionicLoading.show();

        $scope.tmpl = new Object();
        $scope.srvyResult = new Object();

        if ($scope.tmplInfo.display == "SLIDE") {
            $ionicSlideBoxDelegate.$getByHandle('slideTmplList').update();
            $ionicSlideBoxDelegate.$getByHandle('slideTmplList').slide(0);
        }

        // 加载模板
        SrvyService.items(tmplId).then(function (data) {
            $scope.tmpl = data.QSTN_LIST;
            $scope.tmplInfo.name = data.TMPL_NAME;
            $scope.tmplInfo.id = data.TMPL_ID;
            $scope.tmplInfo.display = data.TMPL_DISPLAY;
            $scope.qstnCount = $scope.tmpl.length;

            $scope.isLoadFinish_Tmpl = true;

            $ionicScrollDelegate.resize();
            $ionicScrollDelegate.scrollTop();

            if ($scope.tmplInfo.display == "SLIDE") {
                $timeout(function () {
                    $scope.$broadcast('slideTmplList.init');
                    $ionicLoading.hide();
                }, 300);
            } else {
                $ionicLoading.hide();
            }
        })

        $scope.srvyList = [];
        $scope.srvyModal.show();
    }

    // 隐藏问卷填写信息
    $scope.hideTmpl = function () {
        $scope.srvyModal.hide();
    }

    // 保存问卷结果
    $scope.saveResult = function () {
        $ionicLoading.show();
        if ($scope.taskId.length > 0) {
            flupSrvyService.saveRecord($scope.tmplInfo.id, $scope.currentRec, $scope.vpId, $scope.taskId, $scope.patientId, $scope.srvyResult).then(function (data) {
                if (data.result == 1) {
                    if (data.nTmplId != '') {
                        $scope.loadTmpl(data.nTmplId);
                    } else {
                        $scope.initTmpl();
                        $scope.showFeedback(data.recId);
                        $scope.loadSrvyInfo();
                    }
                } else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                $ionicLoading.hide();
            });
        } else {
            // 主动随访
            SrvyService.saveRecord($scope.tmplInfo.id, $scope.currentRec, $scope.vpId, $scope.srvyResult).then(function (data) {
                if (data.result == 1) {
                    if (data.nTmplId != '') {
                        $scope.loadTmpl(data.nTmplId);
                    } else {
                        $scope.initTmpl();
                        $scope.showFeedback(data.recId);
                        $scope.loadSrvyInfo();
                    }
                } else {
                    $fwCordovaToast.showShortBottom(data.msg);
                }
                $ionicLoading.hide();
            });
        }
    }

    // 初始化题目信息（防止再次进入显示混乱）
    $scope.initTmpl = function () {
        $fwCordovaToast.showShortBottom("问卷填写完成！");
        $scope.tmpl = new Object();
        $scope.tmplInfo = new Object();
        $scope.qstnCount = 0;
        $scope.hideTmpl();
    }

    // 显示反馈信息
    $scope.showFeedback = function (recId) {
        SrvyService.getFeedBack(recId).then(function (data) {
            $scope.tmpl = data.QSTN_LIST;
            $scope.srvyResult = data.REC_QSTN;
            $scope.fbResultList = data.FB_RESULT_LIST;
            $scope.fbCalcList = data.FB_CALC_LIST;
            $scope.fbResultCount = Object.getOwnPropertyNames($scope.fbResultList).length;

            $ionicScrollDelegate.$getByHandle("scrollFeedback").resize();
            $ionicScrollDelegate.$getByHandle("scrollFeedback").scrollTop();
            $scope.feebbackTab = 0;

            $ionicSlideBoxDelegate.$getByHandle('slideFeedback').enableSlide(false);

            $scope.feedbackModal.show();
        });
    }

    // 切换
    $scope.feedbackTabChange = function (index) {
        $scope.feebbackTab = index;
        $ionicSlideBoxDelegate.$getByHandle('slideFeedback').slide(index);

        $ionicScrollDelegate.$getByHandle("scrollFeedback").resize();
        $ionicScrollDelegate.$getByHandle("scrollFeedback").scrollTop();
    }

    // 隐藏反馈信息
    $scope.hideFeedback = function () {
        $scope.feedbackModal.hide();
        $scope.tmpl = new Object();
        $scope.srvyResult = new Object();
    }
    //#endregion


    // #region 健康记录 健康宣教
    // 健康记录跳转
    $scope.goHealth = function (HLTH_NAME) {
        var tileHrefSrvy = '';
        switch (HLTH_NAME) {
            case '':
                // $state.go("app.health", { vpid: $scope.vpId, from: "flupSrvy" });
                $scope.toSlide(2);
                break;
            case '血压':
            case '心率':
            case '血糖':
            case '身高体重':
            case '特殊事件':
                $state.go("app.health", { vpid: $scope.vpId, from: "flupSrvy", titleName: HLTH_NAME });
                break;
            case '饮食':
                $state.go('app.diet', { vpid: $scope.vpId, from: "flupSrvy" });
                break;
            case '吸烟':
                tileHrefSrvy = 'FAGERSTORM';
            case '运动':
                tileHrefSrvy = 'IPAQ';
            case '睡眠':
                tileHrefSrvy = 'PSQI';
            case '焦虑':
                tileHrefSrvy = 'SAS';
                $state.go('app.srvy', { vpid: $scope.vpId, type: tileHrefSrvy, from: "flupSrvy" });
                break;
            case '风险预测':
                $state.go('app.cvdriskList', { vpid: $scope.vpId, from: "flupSrvy" });
                break;
        }
    }

    $scope.changeArticleList = function () {

    }
    //#endregion

    // 初始化
    $scope.$on('$ionicView.loaded', function () {
        // 加载随访任务
        $scope.loadSrvyInfo();
    })
    //#endregion

    // 后退
    $scope.goBack = function () {
        if ($scope.step > 0) {
            $scope.toSlide(0);
            for (var i = 0; i < $scope.flupList.length; i++) {
                if ($scope.patientId == $scope.flupList[i].PATIENT_ID) {
                    $scope.activeTask = i;
                }
            }
        } else {
            $state.go('app.home');
        }
    }

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $rootScope.goBack();
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'flupSrvy');
    })

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideFlupList.enableSlide(false);
    })

    // 页面退出，解除后退绑定
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'flupSrvy') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })
});