﻿angular.module('fwapp.controllers')

// 住院登记
.controller('IpRegController', function ($scope, $rootScope, $state, $stateParams, $timeout, $http, $timeout, $fwCordovaToast
, IpRegService, VisitPatientService, AccountService, RequestService
, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet, $cordovaDatePicker) {
    // 检查登录状态
    $rootScope.checkLogin();
    // 定义住院登记滑块
    var slideIpReg = $ionicSlideBoxDelegate.$getByHandle('slideIpReg');

    // 传入就诊人ID
    $scope.inVpid = $stateParams.vpid;
    // 打哪儿来
    $scope.from = $stateParams.from;
    // 扫码hisCardNum
    $scope.hisCardNum = $stateParams.hisCardNum;
    // 扫码ipNoticeId
    $scope.ipNoticeId = $stateParams.ipNoticeId;
    // 初始滑块状态
    $scope.step = 0;
    // 用户须知数据
    $scope.agreement = new Object();
    // 当前住院单人年龄
    $scope.ipNoticeAge = 0;
    // 字典项数组
    $scope.dict = {
        prvn: [],
        origin_place_city: [],
        birthplace_city: [],
        nrcms_city: [],
        household_city: [],
        address_city: [],
        origin_place_dstr: [],
        birthplace_dstr: [],
        nrcms_dstr: [],
        household_dstr: [],
        address_dstr: [],
        dstr: [],
        nation: [],
        marrage: [],
        rlatship: [],
        job: []
    }

    // 已选择就诊人
    $scope.vpSelect = {};
    // 就诊人绑卡模型
    $scope.vpBind = {
        id: '',
        name: '',
        card_num: '',
        phone_num: null,
        veri_code: '',
        patient_id: '',
        is_self: 0,
        imageVericode: ''
    }
    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};
    // 绑卡帮助
    $scope.configData = {};
    $scope.configData.bindCardHelp = "";

    // 当前用户住院单列表
    $scope.ipNoticeList = [];
    // 是否1岁以下
    $scope.isBaby = false;
    // 是否正在获取住院单列表
    $scope.isLoadingIpNoticeList = false;

    // 住院登记信息
    $scope.ipReg = {};
    $scope.ipRegOri = {};

    // 住院预约信息 wxh
    $scope.ipRegAppt = { EXPECTED_IP_DATE : '', EXPECTED_BED_TYPE : '' };
    // 是否真机 wxh
    $scope.isDevice = (window.cordova && window.cordova.plugins) ? true : false;
    // 床位类型 wxh
    $scope.bedTypeList = ["单人间","双人间","多人间"];
    // 初始就诊人信息
    $scope.IpDateNotice = "";

    // 基础字典类型列表
    $scope.baseDictTypeList = ["AREA", "NATION", "MARRAGE", "RLATSHIP", "JOB"];
    // 级联字典类型列表 籍贯,出生地,新农合,户口,现住址
    $scope.childDictTypeList = ["ORIGIN_PLACE", "BIRTHPLACE", "NRCMS", "HOUSEHOLD", "ADDRESS"];
    // 二级级联字典类型列表 出生地,新农合,户口,现住址
    $scope.grandchildDictTypeList = ["BIRTHPLACE", "NRCMS", "HOUSEHOLD", "ADDRESS"];
    // 初始化获取基础字典数量
    $scope.initBaseDictCount = 0;
    // 初始化获取级联字典数量
    $scope.initChildDictCount = 0;
    // 初始化获取二级级联字典数量
    $scope.initGrandchildDictCount = 0;
    // 2019.02.21 SDX 二维码扫描住院单信息
    $scope.hisIpRegNotice = {
        PATIENT_ID:"",
        HIS_IP_NOTICE_ID:""
    };
    // 2021-4-14 09:30:50 功能开关
    $scope.funcSwitch = {
        // 住院登记填写拟入院日期、床位类型开关
        ipRegDateBedServerStatus: devMode ? true : false,
        // 住院登记填写拟入院日期白名单状态
        ipRegDateServerStatus: devMode ? true : false
    };

    // 注册模态窗口：添加就诊人
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('addVisitPatient.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.addVisitPatientModal = modal;
    });

    // 注册模态窗口：绑定就诊卡
    $ionicModal.fromTemplateUrl('bindCard.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardModal = modal;
    });

    // 注册模态窗口：绑定就诊卡帮助
    $ionicModal.fromTemplateUrl('bindCardHelp.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.bindCardHelpModal = modal;
    });

    // 注册模态窗口：入院须知
    $ionicModal.fromTemplateUrl('ipRegNotice.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.ipRegNoticeModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.addVisitPatientModal.remove();
        $scope.bindCardModal.remove();
        $scope.bindCardHelpModal.remove();
        $scope.ipRegNoticeModal.remove();
    })

    // 滑到下一步
    $scope.nextSlide = function () {
        slideIpReg.next();
        $scope.step = slideIpReg.currentIndex();
    }

    // 后退 重写goBack
    $scope.goBack = function () {
        // 第一页按历史记录返回 或 来自消息中心
        if ($scope.step == 0 || $scope.from == "app.message") {
            $rootScope.goBack();
        }
        // 来自二维码扫描
        else if($scope.step == 1 && $scope.from == "qrcode"){
            $rootScope.goBack();
        }
        // 预约返回住院单列表页
        else if($scope.step == 3){
            $scope.toSlide(1);
        }
        // 其他页返回上一个滑块
        else {
            slideIpReg.previous();
            $scope.step = slideIpReg.currentIndex();
        }
    }

    // 滑到指定页 wxh
    $scope.toSlide = function (index) {
        slideIpReg.slide(index);
        $scope.step = slideIpReg.currentIndex();
    }

    // 滑块切换
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }
    // 添加就诊人模态窗口显示
    $scope.addVisitPatientShow = function () {
        $scope.vpNew = new Object();
        $scope.addVisitPatientModal.show();
    }
    // 添加就诊人模态窗口隐藏
    $scope.addVisitPatientHide = function () {
        $scope.addVisitPatientModal.hide();
        $scope.vpNew = new Object();
    }
    // 添加就诊人确认
    $scope.addVisitPatient = function () {
        // 防止连击
        if (isFastClick()) {
            return;
        }
        // TODO:合法性判断
        $scope.disableAddVP = true;
        VisitPatientService.addVisitPatient($scope.vpNew.realName, $scope.vpNew.idCardCode).then(function (data) {
            // 添加成功
            if (data.result == 1) {
                $scope.loadVpList();
                $scope.addVisitPatientModal.hide();
                $scope.vpNew = new Object();
                $fwCordovaToast.showLongBottom("添加就诊人成功");
            }
            // 添加失败
            else {
                var alertPopup = $ionicPopup.alert({
                    title: '添加失败',
                    template: data.msg
                });
            }
            $scope.disableAddVP = false;
        }, function (data) {
            $scope.disableAddVP = false;
        })
    }
    //#region 绑定就诊卡
    // 绑卡模态窗口显示
    $scope.bindCardShow = function () {
        // 获取图片验证码
        $scope.getImageVericode();
        $scope.vpBind.id = $scope.vpSelect.VISIT_PATIENT_ID;
        $scope.vpBind.name = $scope.vpSelect.VISIT_PATIENT_NAME;
        // 绑卡帮助为空时获取
        if ($scope.configData.bindCardHelp == "" || $scope.configData.bindCardHelp.length == 0) {
            $ionicLoading.show();
            // 获取绑卡帮助和本人关系说明
            IpRegService.getBindCardHelp().then(function (data) {
                // 获取成功
                if (data.result == 1) {
                    $scope.configData.bindCardHelp = data.data.bindCardHelp;
                    $scope.configData.isSelfDescr = data.data.isSelfDescr;
                }
                // 获取失败
                else {
                    $fwCordovaToast.showLongBottom("网络异常,请稍后重试");
                }
                $ionicLoading.hide();
            })
        }
        $scope.bindCardModal.show();
    }
    // 绑卡模态窗口隐藏
    $scope.bindCardHide = function () {
        $scope.bindCardModal.hide();
        $scope.vpBind = {
            id: '',
            name: '',
            card_num: '',
            phone_num: null,
            veri_code: '',
            patient_id: '',
            is_self: 0
        };
    }
    // 绑卡帮助模态窗口显示
    $scope.bindCardHelpShow = function () {
        $scope.bindCardHelpModal.show();
    }
    // 绑卡帮助模态窗口隐藏
    $scope.bindCardHelpHide = function () {
        $scope.bindCardHelpModal.hide();
    }
    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.vpBind.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }
    // 2017-5-9 10:55:51 就诊卡号验证
    $scope.checkCardNum = function () {
        var regex = /^([0-9]|x|X)*$/;
        // 验证失败
        if (!regex.exec($scope.vpBind.card_num)) {
            $fwCordovaToast.showLongBottom("就诊卡号不合法，请检查后再次输入");
            return false;
        }
        else {
            // 小写x转大写X
            if ($scope.vpBind.card_num.indexOf("x") > -1) {
                $scope.vpBind.card_num = $scope.vpBind.card_num.toUpperCase();
            }
            return true;
        }
    }
    // 绑卡提交
    $scope.bindCardSubmit = function () {
        console.log($scope.vpBind);
        if (!$scope.checkCardNum()) {
            return false;
        }
        if ($scope.vpBind.patient_id == '' || $scope.vpBind.card_num == '' || $scope.vpBind.veri_code == '' || $scope.vpBind.patient_id == '' || $scope.vpBind.is_self == 0) {
            $fwCordovaToast.showLongBottom('请完整填写就诊人信息');
            return false;
        }
        $ionicLoading.show();
        VisitPatientService.bindVisitPatient($scope.vpBind.id, $scope.vpBind.patient_id, $scope.vpBind.card_num, $scope.vpBind.phone_num, $scope.vpBind.veri_code, $scope.vpBind.is_self).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showLongBottom(data.msg);
            } else {
                $scope.bindCardHide();     // 隐藏绑定页面
                $scope.loadVpList();            // 重新获取患者信息
                // 2017.7.28 孙老师要求开通预存账户需上传身份证
                //$scope.toSlide(2);
                $fwCordovaToast.showLongBottom('就诊卡绑定成功');
            }
            $ionicLoading.hide();
        })
    }
    // 检查患者信息，若一致，调用获取验证码方法
    $scope.checkPatientInfo = function () {
        // 验证图片验证码
        if ($scope.vpBind.imageVericode == null || $scope.vpBind.imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空'
            });
            return;
        }
        $ionicLoading.show();
        RequestService.checkPatientCard($scope.vpBind.id, $scope.vpBind.card_num, $scope.vpBind.phone_num).then(function (data) {
            console.log(data);
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showLongBottom('连接超时，请重试');
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showLongBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showLongBottom(data.msg == '未找到相应信息' ? '未找到相应的患者信息，请检查就诊卡号、预留手机号是否正确' : data.msg);
                return;
            }
            // 正常有结果
            $scope.vpBind.patient_id = data.data[0].PATIENT_ID;
            console.log($scope.vpBind.patient_id);
            $scope.getVericode();
        });
    }
    // 获取验证码
    $scope.getVericode = function () {
        AccountService.sendVericodeByPhone($scope.vpBind.phone_num, '5', $scope.vpBind.imageVericode).then(function (data) {
            // 发送成功
            if (data.result == 1) {
                // 倒计时
                $scope.timespan = 60;
                TimeCount();
            }
            // 服务调用失败
            else if (data.result == 0) {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg
                });
            }
            // 发送次数过多
            else {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: '获取验证码失败，请稍后重试'
                });
            }
        })
    }
    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
        }
    };
    //#endregion

    // 选择住院单
    $scope.selectIpNotice = function (index) {
        if ($scope.ipNoticeList[index].NOTICE_STATUS != "0" && $scope.ipNoticeList[index].NOTICE_STATUS != "1") {
            $fwCordovaToast.showLongBottom($scope.ipNoticeList[index].NOTICE_STATUS_REMARK);
            return;
        }
        // 2019.02.22 BST 修复进入填写页面后退后，再次进入级联项不显示问题，需要重置一下$scope.ipReg
        $scope.ipReg = {};
        // 2019-8-16 19:07:11 获取已选择住院单信息 供前端判断是否1岁以下
        $scope.isBaby = $scope.ipNoticeList[index].AGE.length > 0 && $scope.ipNoticeList[index].AGE.indexOf('岁') == -1;
        // 2021-11-24 15:55:39 CGZ 获取患者年龄数字用于婚姻及家属关系验证 带岁字 且 不带/ 为大于6岁 年龄去掉岁字转换为数字 否则记为0
        var ageNum = 0;
        if ($scope.ipNoticeList[index].AGE.indexOf('岁') > -1 && $scope.ipNoticeList[index].AGE.indexOf('/') == -1) {
            ageNum = Number($scope.ipNoticeList[index].AGE.substr(0, $scope.ipNoticeList[index].AGE.length - 1));
        }
        $scope.ipNoticeAge = ageNum;
        if ($scope.from == 'qrcode') {
            $scope.getLastIPRegLastInfoV2(index);
            return;
        }
        var indexVp = -1;
        if ($scope.ipNoticeList.length > index && $scope.vpList.length > 0) {
            var vpFilter = $scope.vpList.filter(e => e.HIS_CARD_NUM == $scope.ipNoticeList[index].PATIENT_ID);
            if (vpFilter.length > 0) {
                indexVp = $scope.vpList.indexOf(vpFilter[0]);
            }
        }
        // 继续原流程
        if (indexVp >= -1) {
            $scope.selectVp(indexVp);
        }
        else {
            $fwCordovaToast.showLongBottom('未找到当前就诊人住院单信息，暂时无法使用此功能');
        }
    }

    //选择预约时间 wxh
    $scope.selectExpectedDate = function () {
          var value = new Date(new Date().setDate(new Date().getDate() + 14)).Format('yyyy-MM-dd');
          var defaultDate = new Date(new Date().setDate(new Date().getDate() + 14));
          if (value != null && value != '') {
              // 处理iOS日期格式
              if (currentPlatform == "iOS") {
                  value = value.replace(/-/g, "/");
              }
              defaultDate = new Date(value);
          }
          var options = {
              mode: 'date',  	// 'date' or 'time' or 'datetime'
              date: defaultDate,
              maxDate: new Date(new Date().setDate(new Date().getDate() + 30)),//new Date() + 30 * 24 * 3600 * 1000,
              minDate: new Date(new Date().setDate(new Date().getDate() + 14)),
              okText: '确定',
              cancelText: '取消',
              doneButtonLabel: '确定',
              cancelButtonLabel: '取消',
              is24Hour: true,
              androidTheme: 3,
              locale: 'zh_cn'
          };

          $cordovaDatePicker.show(options).then(function (date) {
              if (typeof (date) != 'undefined') {
                  $scope.ipRegAppt.EXPECTED_IP_DATE = new Date(date).Format('yyyy-MM-dd');
              }
          });
      };

    //选择住院预约 wxh
    $scope.selectIpNoticeDate = function(index){
        $ionicLoading.show();
        $scope.IpDateNotice = $scope.ipNoticeList[index];
        // 2021-03-11 20:01:00 默认时间为两周后
        $scope.ipRegAppt = { EXPECTED_IP_DATE : new Date(new Date().setDate(new Date().getDate() + 14)).Format('yyyy-MM-dd'), EXPECTED_BED_TYPE : '' };
        IpRegService.getIPNoticeExpectedDate($scope.IpDateNotice.OUTPATIENT_ID,$scope.IpDateNotice.HIS_IP_NOTICE_ID).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 2021-03-11 20:01:00 data.data首次录入为空
                if (data.data != null && data.data != '') {
                    $scope.ipRegAppt.EXPECTED_IP_DATE = new Date(data.data.EXPECTED_IP_DATE).Format('yyyy-MM-dd');
                    if(data.data.EXPECTED_BED_TYPE != null){
                        $scope.ipRegAppt.EXPECTED_BED_TYPE = "" + data.data.EXPECTED_BED_TYPE;
                    }
                }

                // 2021-4-27 20:16:07 增加预约入院日期白名单 只有白名单内可见
                if (devMode || data.ipRegDateServerStatus) {
                    // 住院登记填写拟入院日期白名单状态
                    $scope.funcSwitch.ipRegDateServerStatus = true;
                }

                $scope.toSlide(3);
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom("网络异常,请稍后重试");
            }
            $ionicLoading.hide();
        })
        event.stopPropagation();
    }

    // 预约提交 wxh
    $scope.saveExpected = function(){
        // 2021-4-27 20:58:32 由于只有白名单用户可填写期望入院日期 取消限制
        if($scope.funcSwitch.ipRegDateServerStatus){
            if($scope.ipRegAppt.EXPECTED_IP_DATE == "年-月-日" || $scope.ipRegAppt.EXPECTED_IP_DATE == ""){
                $fwCordovaToast.showLongBottom('"期望入院日期"不得为空，请检查后再试');
                return;
            }
            if($scope.dateFormat(new Date($scope.ipRegAppt.EXPECTED_IP_DATE)) < $scope.dateFormat(new Date()) ||
                $scope.dateFormat(new Date($scope.ipRegAppt.EXPECTED_IP_DATE)) > $scope.dateFormat(new Date(new Date().setDate(new Date().getDate() + 30)))){
                $fwCordovaToast.showLongBottom('"期望入院日期"不可超过未来30天的范围，请检查后再试');
                return;
            }
        }
        if($scope.ipRegAppt.EXPECTED_BED_TYPE == "" ){
            $fwCordovaToast.showLongBottom('"期望床位类型"不得为空，请检查后再试');
            return;
        }
        $ionicLoading.show();
        IpRegService.addIPNoticeExpectedDate($scope.ipRegAppt.EXPECTED_IP_DATE,$scope.ipRegAppt.EXPECTED_BED_TYPE,
        $scope.IpDateNotice.PATIENT_NAME,$scope.IpDateNotice.OUTPATIENT_ID,$scope.IpDateNotice.HIS_IP_NOTICE_ID).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                $fwCordovaToast.showLongBottom("提交成功");
                $scope.goBack();
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom("网络异常,请稍后重试");
            }
            $ionicLoading.hide();
        })

    }
    //格式化时间
    $scope.dateFormat = function(i) {
        var tf = function (e) {
            return (e < 10 ? '0' : '') + e;
        }
        var df = tf(i.getFullYear()) + "-" + tf(i.getMonth() + 1) + "-" + tf(i.getDate());
        return new Date(df);
    }

    // 选择就诊人
    $scope.selectVp = function (index) {
        // 防止连击
        if (isFastClick()) {
            return;
        }

        // 就诊人id
        $scope.vpSelect = $scope.vpList[index];
        // 判断绑卡状态
        if ($scope.vpSelect.IS_BIND_CARD != 1) {
            // 显示绑卡提示
            var bindCardPopup = $ionicPopup.show({
                title: '提示',
                template: '就诊人未绑定就诊卡，请绑卡后再试',
                buttons: [{
                    text: '确定',
                    type: 'button-positive',
                    onTap: function (e) {
                        bindCardPopup.close();
                        // 不加timeout popup关不掉
                        $timeout(function () {
                            $scope.bindCardShow();
                        }, 0);
                    }
                }]
            });
            //$fwCordovaToast.showLongBottom("就诊人未绑定就诊卡，请先到个人中心-就诊人管理进行绑卡操作");
            return;
        }
        $ionicLoading.show();
        // HIS验证住院单信息
        IpRegService.checkIPNotice($scope.vpSelect.VISIT_PATIENT_ID).then(function (data) {
            console.log(data);
            // 链接超时
            if (data.result == 99) {
                $ionicLoading.hide();
                $fwCordovaToast.showLongBottom("连接超时，请稍后重试");
                return;
            }
            // 空结果
            if (data.is_null == 1) {
                $ionicLoading.hide();
                $fwCordovaToast.showLongBottom('未找到当前就诊人住院单信息，暂时无法使用此功能');
                return;
            }
            // 正常有结果
            // 获取已填写过的住院登记信息
            IpRegService.getIpReg($scope.vpSelect.VISIT_PATIENT_ID).then(function (dataIpReg) {
                console.log(dataIpReg);
                if (dataIpReg.result == 0) {
                    $fwCordovaToast.showLongBottom(dataIpReg.msg);
                    return;
                }
                // 编辑已有数据
                if (dataIpReg.data.IP_REG_ID != null && dataIpReg.data.IP_REG_ID.length > 0) {
                    // 新生儿体重string-->number 防止ng-model报错
                    if (dataIpReg.data.NEWBORN_WEIGHT != null && dataIpReg.data.NEWBORN_WEIGHT.length > 0) {
                        dataIpReg.data.NEWBORN_WEIGHT = Number(dataIpReg.data.NEWBORN_WEIGHT);
                    }
                    // 赋值给脏检测源数据
                    $.extend($scope.ipRegOri, dataIpReg.data);
                    // 获取市/县字典
                    $scope.getRlatDict(dataIpReg);
                    // 深度复制
                    // 2021-4-18 19:36:14 这里如果不注释掉 会导致多次赋值 select不会被选中
                    //$.extend($scope.ipReg, dataIpReg.data);
                    //$ionicLoading.hide();
                    // 滑到下一页
                    slideIpReg.next();
                    $scope.step = slideIpReg.currentIndex();
                }
                // 新建数据
                else {
                    var ipNoticeFilter = $scope.ipNoticeList.length > 0 ? $scope.ipNoticeList.filter(e => e.PATIENT_ID == $scope.vpSelect.HIS_CARD_NUM) : [];
                    var isRehospital = ipNoticeFilter.length > 0 && ipNoticeFilter[0].REHOSPITALIZATION == "1";
                    var gotRehospital = false;
                    // 非首次住院
                    if (isRehospital) {
                        // 从HIS获取上次住院信息 (说人话就是这哥们原先住过院, 但是没用APP填过住院登记信息)
                        IpRegService.getLastIPRegInfo($scope.vpSelect.VISIT_PATIENT_ID).then(function (dataHIS) {
                            console.log(dataHIS);
                            // 获取成功
                            if (dataHIS.result == 1) {
                                // 住院单信息不为空
                                if (dataHIS.is_null == 0) {
                                    gotRehospital = true;
                                    // 需要赋值的key集合
                                    var keys = Object.keys(dataHIS.data[0]);
                                    var keysExcept = ["LAST_IP_REG_ID", "REQUEST_ID", "PATIENT_ID", "VISIT_PATIENT_NAME"];
                                    for (var i in keysExcept) {
                                        var index = keys.indexOf(keysExcept[i]);
                                        if (index > -1) {
                                            keys.splice(index, 1);
                                        }
                                    }
                                    // 赋值
                                    for (var i in keys) {
                                        dataIpReg.data[keys[i]] = dataHIS.data[0][keys[i]];
                                    }
                                    // 新生儿体重string-->number 防止ng-model报错
                                    if (dataIpReg.data.NEWBORN_WEIGHT != null && dataIpReg.data.NEWBORN_WEIGHT.length > 0) {
                                        dataIpReg.data.NEWBORN_WEIGHT = Number(dataIpReg.data.NEWBORN_WEIGHT);
                                    }
                                    // 赋值给脏检测源数据
                                    $.extend($scope.ipRegOri, dataIpReg.data);
                                    // 获取市/县字典
                                    $scope.getRlatDict(dataIpReg);
                                    // 深度复制
                                    $.extend($scope.ipReg, dataIpReg.data);
                                    $ionicLoading.hide();
                                    // 滑到下一页
                                    slideIpReg.next();
                                    $scope.step = slideIpReg.currentIndex();
                                }
                                // 住院单信息为空
                                else {
                                    // 赋值给脏检测源数据
                                    $.extend($scope.ipRegOri, dataIpReg.data);
                                    // 深度复制
                                    $.extend($scope.ipReg, dataIpReg.data);
                                    $ionicLoading.hide();
                                    // 滑到下一页
                                    slideIpReg.next();
                                    $scope.step = slideIpReg.currentIndex();
                                }
                            }
                        }, function (errHIS) {
                            console.log(errHIS);
                        });
                    }
                    // 首次住院 或 非首次入院但未获取到上次入院信息
                    // 2021-4-14 15:46:02 这里有BUG 上边的异步请求还没返回 gotRehospital值未变 先进入此分支 导致.next()执行了两遍 应该放在else里以及回调函数中
                    //if (!isRehospital || !gotRehospital) {
                    // 首次入院
                    else {
                        // 赋值给脏检测源数据
                        $.extend($scope.ipRegOri, dataIpReg.data);
                        // 深度复制
                        $.extend($scope.ipReg, dataIpReg.data);
                        $ionicLoading.hide();
                        // 滑到下一页
                        slideIpReg.next();
                        $scope.step = slideIpReg.currentIndex();
                    }
                }
            });
        }, function (data) {
            $ionicLoading.hide();
            $fwCordovaToast.showLongBottom(data.msg);
        });
    }

    // 获取最新的getLastIPRegInfoV2
    $scope.getLastIPRegLastInfoV2 = function(index){
        $ionicLoading.show();

        $scope.hisIpRegNotice = $scope.ipNoticeList[index];
        // 校验是否已填写
        IpRegService.checkIpRegV2($scope.hisIpRegNotice["PATIENT_ID"], $scope.hisIpRegNotice["HIS_IP_NOTICE_ID"]).then(function(data){
            // 未填写 查询his
            if(data.is_null == 1) {
                IpRegService.getLastIPRegInfoV2("", $scope.hisIpRegNotice["PATIENT_ID"], $scope.hisIpRegNotice["HIS_IP_NOTICE_ID"]).then(function(data){
                    console.log(data)
                    // 链接超时
                    if (data.result == 99) {
                        $ionicLoading.hide();
                        $fwCordovaToast.showLongBottom("连接超时，请稍后重试");
                        return;
                    }
                    // 空结果
                    if (data.is_null == 1) {
                        // 本地新建填写
                        $scope.getIpRegV2($scope.hisIpRegNotice);
                        return;
                    }
                    if(data.data.length > 0){
                        var hisData = data.data[0];
                        // 新生儿体重string-->number 防止ng-model报错
                        if (hisData.NEWBORN_WEIGHT != null && hisData.NEWBORN_WEIGHT.length > 0) {
                            hisData.NEWBORN_WEIGHT = Number(hisData.NEWBORN_WEIGHT);
                        }
                        // 赋值给脏检测源数据
                        $.extend($scope.ipRegOri, hisData);
                        // 获取市/县字典
                        var getChild = $scope.getRlatDict(new Object({data:hisData}));
                        // 若获取了市县字典，会在获取完毕后完成复制及取消LOADING
                        // 对于新申请无需获取市县字典的，需要在这里手动调用
                        // 待优化
                        if (!getChild) {
                            // 深度复制
                            $.extend($scope.ipReg, hisData);
                            $ionicLoading.hide();
                        }

                        // 滑到下一页
                        slideIpReg.next();
                        $scope.step = slideIpReg.currentIndex();
                    }
                },function(error){
                    console.log(error)
                    $ionicLoading.hide();
                    $fwCordovaToast.showLongBottom(error.msg);
                });
            } else { // 本地新建填写
                $scope.getIpRegV2($scope.hisIpRegNotice);
            }
        },function(error){
            $fwCordovaToast.showLongBottom('网络连接失败');
        })

    }
    // 本地新建住院单信息并填写
    $scope.getIpRegV2 = function(hisIpRegNotice){
        // 获取已填写的住院单
        IpRegService.getIpRegV2(hisIpRegNotice.PATIENT_ID, hisIpRegNotice.HIS_IP_NOTICE_ID, hisIpRegNotice.PATIENT_NAME).then(function(data){
            if(data.result == 1){
                // 新生儿体重string-->number 防止ng-model报错
                if (data.data.NEWBORN_WEIGHT != null && data.data.NEWBORN_WEIGHT.length > 0) {
                    data.data.NEWBORN_WEIGHT = Number(data.data.NEWBORN_WEIGHT);
                }
                data.data.IP_REG_ID = "";
                // 赋值给脏检测源数据
                $.extend($scope.ipRegOri, data.data);
                // 获取市/县字典
                var getChild = $scope.getRlatDict(data);
                // 若获取了市县字典，会在获取完毕后完成复制及取消LOADING
                // 对于新申请无需获取市县字典的，需要在这里手动调用
                // 待优化
                if (!getChild) {
                    // 深度复制
                    $.extend($scope.ipReg, data.data);
                    $ionicLoading.hide();
                }
                // 滑到下一页
                slideIpReg.next();
                $scope.step = slideIpReg.currentIndex();
            } else {
                $ionicLoading.hide();
            }
        },function(error){
            $ionicLoading.hide();
            $fwCordovaToast.showLongBottom(error.msg);
        })
    }

    // 获取关联字典
    $scope.getRlatDict = function (data) {
        var toGetChildDict = false;
        // 获取市/县字典
        for (var type in $scope.childDictTypeList) {
            // 如果有省份数据 获取城市字典
            if (data.data[$scope.childDictTypeList[type] + "_PRVN"] != null && data.data[$scope.childDictTypeList[type] + "_PRVN"].length > 0) {
                toGetChildDict = true;
                $scope.initChildDictCount++;
                $scope.getChildDict($scope.childDictTypeList[type], "PRVN", data.data[$scope.childDictTypeList[type] + "_PRVN"], true);
            }
        }
        return toGetChildDict;
    }

    // 滚动至id
    $scope.anchorScroll = function (id) {
        $ionicScrollDelegate.scrollTo(0, ($("#" + id)[0].offsetTop + 1), true);
    }

    // 保存点击
    $scope.saveClick = function () {
        // 表单验证
        // 2019-8-16 19:15:46 婴儿验证 其余清空
        if ($scope.isBaby) {
            if ($scope.ipReg.BIRTH_HOSPITAL == null || $scope.ipReg.BIRTH_HOSPITAL.length == 0) {
                $scope.anchorScroll("BIRTH_HOSPITAL");
                $fwCordovaToast.showLongBottom('“出生医院”不得为空，请填写后再试');
                return;
            }
            if ($scope.ipReg.BIRTH_HOSPITAL && $scope.ipReg.BIRTH_HOSPITAL.length > 25) {
                $scope.anchorScroll("BIRTH_HOSPITAL");
                $fwCordovaToast.showLongBottom('“出生医院”不得超过25字，请修改后再试');
                return;
            }
            // 2021-4-18 19:53:31 虽然不知道微信为啥注释掉了 但是保持与微信同步
//            if ($scope.ipReg.NEWBORN_WEIGHT && (typeof ($scope.ipReg.NEWBORN_WEIGHT) != "number" || $scope.ipReg.NEWBORN_WEIGHT % 1 != 0
//                || $scope.ipReg.NEWBORN_WEIGHT < 0 || $scope.ipReg.NEWBORN_WEIGHT >= 10000000)) {
//                $scope.anchorScroll("NEWBORN_WEIGHT");
//                $fwCordovaToast.showLongBottom('“新生儿体重”不正确,请检查后再试');
//                return;
//            }
        }
        else {
            $scope.ipReg.BIRTH_HOSPITAL = "";
            $scope.ipReg.NEWBORN_WEIGHT = 0;
        }
        // 2021-4-18 20:58:52 增加非空验证 与微信同步
        if ($scope.ipReg.NATION == null || $scope.ipReg.NATION.length == 0) {
            $scope.anchorScroll("NATION");
            $fwCordovaToast.showLongBottom('“民族”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.MARRIAGE == null || $scope.ipReg.MARRIAGE.length == 0) {
            $scope.anchorScroll("MARRIAGE");
            $fwCordovaToast.showLongBottom('“婚姻”不得为空，请填写后再试');
            return;
        }
        // 2021-11-19 17:39:03 WX 按变更要求补充婚姻状况及家属关系
        if (($scope.ipReg.MARRIAGE == "2" || $scope.ipReg.MARRIAGE == "3" || $scope.ipReg.MARRIAGE == "4") && $scope.ipNoticeAge < 18) {
            $scope.anchorScroll("MARRIAGE");
            $fwCordovaToast.showLongBottom('“婚姻”与年龄不符，请重新填写');
            return;
        }
        if ($scope.ipReg.JOB == null || $scope.ipReg.JOB.length == 0) {
            $scope.anchorScroll("JOB");
            $fwCordovaToast.showLongBottom('“职业”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.ORIGIN_PLACE_PRVN == null || $scope.ipReg.ORIGIN_PLACE_PRVN.length == 0) {
            $scope.anchorScroll("ORIGIN_PLACE_PRVN");
            $fwCordovaToast.showLongBottom('“籍贯-省”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.ORIGIN_PLACE_CITY == null || $scope.ipReg.ORIGIN_PLACE_CITY.length == 0) {
            $scope.anchorScroll("ORIGIN_PLACE_CITY");
            $fwCordovaToast.showLongBottom('“籍贯-市”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.BIRTHPLACE_PRVN == null || $scope.ipReg.BIRTHPLACE_PRVN.length == 0) {
            $scope.anchorScroll("BIRTHPLACE_PRVN");
            $fwCordovaToast.showLongBottom('“出生地-省”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.BIRTHPLACE_CITY == null || $scope.ipReg.BIRTHPLACE_CITY.length == 0) {
            $scope.anchorScroll("BIRTHPLACE_CITY");
            $fwCordovaToast.showLongBottom('“出生地-市”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.BIRTHPLACE_DSTR == null || $scope.ipReg.BIRTHPLACE_DSTR.length == 0) {
            $scope.anchorScroll("BIRTHPLACE_DSTR");
            $fwCordovaToast.showLongBottom('“出生地-县”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.WORK_ADDRESS == null || $scope.ipReg.WORK_ADDRESS.length == 0) {
            $scope.anchorScroll("WORK_ADDRESS");
            $fwCordovaToast.showLongBottom('“工作单位及地址”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.WORK_ADDRESS && $scope.ipReg.WORK_ADDRESS.length > 20) {
            $scope.anchorScroll("WORK_ADDRESS");
            $fwCordovaToast.showLongBottom('“工作单位及地址”不得超过20字，请修改后再试');
            return;
        }
        if ($scope.ipReg.WORK_TEL && !(/^[0-9|+|\-\| ]{0,20}$/.test($scope.ipReg.WORK_TEL))) {
            $scope.anchorScroll("WORK_TEL");
            $fwCordovaToast.showLongBottom('“单位联系电话”格式不正确或超过20字，请检查后再试');
            return;
        }
        if ($scope.ipReg.WORK_POSTCODE && !(/^[0-9]{0,6}$/.test($scope.ipReg.WORK_POSTCODE))) {
            $scope.anchorScroll("WORK_POSTCODE");
            $fwCordovaToast.showLongBottom('“单位邮编”应为纯数字且不得超过6字，请检查后再试');
            return;
        }
        if ($scope.ipReg.HOUSEHOLD_PRVN == null || $scope.ipReg.HOUSEHOLD_PRVN.length == 0) {
            $scope.anchorScroll("HOUSEHOLD_PRVN");
            $fwCordovaToast.showLongBottom('“户口地址-省”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.HOUSEHOLD_CITY == null || $scope.ipReg.HOUSEHOLD_CITY.length == 0) {
            $scope.anchorScroll("HOUSEHOLD_CITY");
            $fwCordovaToast.showLongBottom('“户口地址-市”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.HOUSEHOLD_DSTR == null || $scope.ipReg.HOUSEHOLD_DSTR.length == 0) {
            $scope.anchorScroll("HOUSEHOLD_DSTR");
            $fwCordovaToast.showLongBottom('“户口地址-县”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.HOUSEHOLD_DETAIL == null || $scope.ipReg.HOUSEHOLD_DETAIL.length == 0) {
            $scope.anchorScroll("HOUSEHOLD_DETAIL");
            $fwCordovaToast.showLongBottom('“户口详细地址”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.HOUSEHOLD_DETAIL && $scope.ipReg.HOUSEHOLD_DETAIL.length > 40) {
            $scope.anchorScroll("HOUSEHOLD_DETAIL");
            $fwCordovaToast.showLongBottom('“户口详细地址”不得超过40字，请检查后再试');
            return;
        }
        if ($scope.ipReg.HOUSEHOLD_POSTCODE && !(/^[0-9]{0,6}$/.test($scope.ipReg.HOUSEHOLD_POSTCODE))) {
            $scope.anchorScroll("HOUSEHOLD_POSTCODE");
            $fwCordovaToast.showLongBottom('“户口地邮编”应为纯数字且不得超过6字，请检查后再试');
            return;
        }
        if ($scope.ipReg.ADDRESS_PRVN == null || $scope.ipReg.ADDRESS_PRVN.length == 0) {
            $scope.anchorScroll("ADDRESS_PRVN");
            $fwCordovaToast.showLongBottom('“现住址-省”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.ADDRESS_CITY == null || $scope.ipReg.ADDRESS_CITY.length == 0) {
            $scope.anchorScroll("ADDRESS_CITY");
            $fwCordovaToast.showLongBottom('“现住址-市”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.ADDRESS_DSTR == null || $scope.ipReg.ADDRESS_DSTR.length == 0) {
            $scope.anchorScroll("ADDRESS_DSTR");
            $fwCordovaToast.showLongBottom('“现住址-县”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.ADDRESS_DETAIL == null || $scope.ipReg.ADDRESS_DETAIL.length == 0) {
            $scope.anchorScroll("ADDRESS_DETAIL");
            $fwCordovaToast.showLongBottom('“现住址详细地址”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.ADDRESS_DETAIL && $scope.ipReg.ADDRESS_DETAIL.length > 40) {
            $scope.anchorScroll("ADDRESS_DETAIL");
            $fwCordovaToast.showLongBottom('“现住址详细地址”不得超过40字，请检查后再试');
            return;
        }
        if ($scope.ipReg.ADDRESS_POSTCODE && !(/^[0-9]{0,6}$/.test($scope.ipReg.ADDRESS_POSTCODE))) {
            $scope.anchorScroll("ADDRESS_POSTCODE");
            $fwCordovaToast.showLongBottom('“现住址邮编”应为纯数字且不得超过6字，请检查后再试');
            return;
        }
        if ($scope.ipReg.TEL == null || $scope.ipReg.TEL.length == 0) {
            $scope.anchorScroll("TEL");
            $fwCordovaToast.showLongBottom('“联系电话”不得为空，请填写后再试');
            return;
        }
        // 2021-11-19 17:39:03 WX 按变更要求限制联系电话为手机号
        if ($scope.ipReg.TEL && !(/^1[3-9][0-9]{9}$/.test($scope.ipReg.TEL))) {
            $scope.anchorScroll("TEL");
            $fwCordovaToast.showLongBottom('“联系电话”需填写手机号码，请检查后再试');
            return;
        }
        if ($scope.ipReg.EMAIL && ($scope.ipReg.EMAIL.length > 50 || !(/^(?:[\w-]+\.?)*[\w-]+@(?:[\w-]+\.)+[\w]{2,4}$/.test($scope.ipReg.EMAIL)))) {
            $scope.anchorScroll("EMAIL");
            $fwCordovaToast.showLongBottom('“Email”格式不正确或超过50字，请检查后再试');
            return;
        }
        if ($scope.ipReg.CONTACT_NAME == null || $scope.ipReg.CONTACT_NAME.length.length == 0) {
            $scope.anchorScroll("CONTACT_NAME");
            $fwCordovaToast.showLongBottom('“家属姓名”不得为空，请填写后再试');
            return;
        }
        if ($scope.ipReg.CONTACT_NAME && $scope.ipReg.CONTACT_NAME.length > 5) {
            $scope.anchorScroll("CONTACT_NAME");
            $fwCordovaToast.showLongBottom('“家属姓名”不得超过5字，请检查后再试');
            return;
        }
        if ($scope.ipReg.CONTACT_RLAT == null || $scope.ipReg.CONTACT_RLAT.length == 0) {
            $scope.anchorScroll("CONTACT_RLAT");
            $fwCordovaToast.showLongBottom('“家属关系”不得为空，请填写后再试');
            return;
        }
        // 2021-11-19 17:39:03 WX 按变更要求补充婚姻状况及家属关系
        if (($scope.ipReg.CONTACT_RLAT == "11" || $scope.ipReg.CONTACT_RLAT == "12"||$scope.ipReg.CONTACT_RLAT == "13" ||$scope.ipReg.CONTACT_RLAT == "14") && $scope.ipNoticeAge < 18) {
            $scope.anchorScroll("CONTACT_RLAT");
            $fwCordovaToast.showLongBottom('“家属关系”与年龄不符，请重新填写');
            return;
        }
        if ($scope.ipReg.CONTACT_TEL == null || $scope.ipReg.CONTACT_TEL.length == 0) {
            $scope.anchorScroll("CONTACT_TEL");
            $fwCordovaToast.showLongBottom('“家属联系电话”不得为空，请填写后再试');
            return;
        }
        // 2021-11-19 17:39:03 WX 按变更要求限制联系电话为手机号
        if ($scope.ipReg.CONTACT_TEL && !(/^1[3-9][0-9]{9}$/.test($scope.ipReg.CONTACT_TEL))) {
            $scope.anchorScroll("CONTACT_TEL");
            $fwCordovaToast.showLongBottom('“家属联系电话”需填写手机号码，请检查后再试');
            return;
        }
        if ($scope.ipReg.CONTACT_ADDRESS && $scope.ipReg.CONTACT_ADDRESS.length > 40) {
            $scope.anchorScroll("CONTACT_ADDRESS");
            $fwCordovaToast.showLongBottom('“家属地址”不得超过40字，请检查后再试');
            return;
        }
        // 序列化数据提交
        var ipReg = $.param($scope.ipReg);
        // 脏检测
        if ($.param($scope.ipRegOri) == ipReg) {
            $fwCordovaToast.showLongBottom('患者信息未修改，无需保存');
            return;
        }
        $ionicLoading.show();
        IpRegService.saveIpReg($scope.ipReg, $scope.vpSelect.VISIT_PATIENT_ID, $scope.hisIpRegNotice.PATIENT_ID, $scope.hisIpRegNotice.HIS_IP_NOTICE_ID, $scope.from, $scope.isBaby, $scope.ipNoticeAge).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showLongBottom(data.msg);
                $ionicLoading.hide();
                return;
            } else {
                // 更新脏检测源数据
                $scope.ipRegOri = {};
                $.extend($scope.ipRegOri, $scope.ipReg);
                // 2018-10-18 09:47:30 改为弹出confirm 可直接返回
                var popupOptions = {
                    title: '保存成功',
                    template: "您已保存成功，请于入院日期到住院收费处办理入院",
                    buttons: [{
                        text: '返回',
                        onTap: function (e) {
                            $scope.goBack();
                        }
                    }, {
                        text: '继续填写',
                        type: 'button-positive'
                    }]
                };
                var confirmPopup = $ionicPopup.show(popupOptions);
                $ionicLoading.hide();
                return;
            }
        })
    }

    // 获取级联字典
    $scope.getChildDict = function (type, level, parentDictCode, isInit, isInit2) {
        if ($scope.childDictTypeList.indexOf(type) == -1) {
            return;
        }
        if (level != "PRVN" && level != "CITY") {
            return;
        }
        if (parentDictCode == null || parentDictCode.length == 0) {
            parentDictCode = $scope.ipReg[type + "_" + level];
        }
        //console.log(parentDictCode);
        // 从有值改为空
        if (!isInit && (parentDictCode == null || parentDictCode == "")) {
            console.log(level);
            // 下级菜单清空
            if (level == "PRVN") {
                $scope.dict[type.toLowerCase() + "_city"] = [];
                $scope.dict[type.toLowerCase() + "_dstr"] = [];
                console.log($scope.dict[type.toLowerCase() + "_city"]);
                console.log($scope.dict[type.toLowerCase() + "_dstr"]);
                // 重置市县
                $scope.ipReg[type + "_CITY"] = "";
                $scope.ipReg[type + "_DSTR"] = "";
            }
            else if (level == "CITY") {
                $scope.dict[type.toLowerCase() + "_dstr"] = [];
                console.log($scope.dict[type.toLowerCase() + "_dstr"]);
                // 重置市
                $scope.ipReg[type + "_DSTR"] = "";
            }
            return;
        }
        IpRegService.getDict("AREA", parentDictCode).then(function (data) {
            // 获取成功
            if (data.result == 1) {
                //console.log(data.data);
                // 字典赋值
                var dictKey = type.toLowerCase();
                if (level == "PRVN") {
                    $scope.dict[dictKey + "_city"] = data.data;
                    if (!isInit) {
                        $scope.dict[dictKey + "_dstr"] = [];
                        // 重置市县
                        $scope.ipReg[type + "_CITY"] = "";
                        $scope.ipReg[type + "_DSTR"] = "";
                    }
                }
                else if (level == "CITY") {
                    $scope.dict[dictKey + "_dstr"] = data.data;
                    if (!isInit) {
                        // 重置市
                        $scope.ipReg[type + "_DSTR"] = "";
                    }
                }
                // 是初始化调用
                if (isInit) {
                    if (!isInit2) {
                        $scope.initChildDictCount--;
                    }
                    else {
                        $scope.initGrandchildDictCount--;
                    }
                    // 并发最后一个回来的
                    if (!isInit2 && $scope.initChildDictCount == 0) {
                        // 如果有城市数据 获取区县字典 (出生地/新农合)
                        for (var key in $scope.grandchildDictTypeList) {
                            if ($scope.ipRegOri[$scope.grandchildDictTypeList[key] + "_CITY"] != null && $scope.ipRegOri[$scope.grandchildDictTypeList[key] + "_CITY"].length > 0) {
                                $scope.initGrandchildDictCount++;
                                $scope.getChildDict($scope.grandchildDictTypeList[key], "CITY", $scope.ipRegOri[$scope.grandchildDictTypeList[key] + "_CITY"], true, true);
                            }
                        }
                    }
                    else if (isInit2 && $scope.initGrandchildDictCount == 0) {
                        console.log($scope.ipRegOri);
                        $timeout(function () {
                            // 深度复制
                            $.extend($scope.ipReg, $scope.ipRegOri);
                            console.log($scope.ipReg);
                            $ionicLoading.hide();
                        }, 500);
                    }
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
        })
    }

    //#region 初始化
    // 加载就诊人列表
    $scope.loadVpList = function () {
        $scope.initBaseDictCount++;
        // 就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            $scope.initBaseDictCount--;
            // 获取成功
            if (data.result == 1) {
                $scope.vpList = data.data;
                //console.log($scope.vpList);
                //console.log($scope.inVpid);
                // 指定就诊人
                if ($scope.inVpid != null && $scope.inVpid != "") {
                    var index = 0;
                    for (var i in $scope.vpList) {
                        if ($scope.vpList[i].VISIT_PATIENT_ID == $scope.inVpid) {
                            index = i;
                        }
                    }
                    // 跳过同意页
                    $scope.nextSlide();
                    // 选择对应就诊人
                    $scope.selectVp(index);
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        })
    }

    // 格式化价格 至少两位小数 返回字符串
    $scope.formatFee = function(fee) {
        var feeShow = "" + fee;
        var lengthFee = feeShow.length;
        var indexPoint = feeShow.indexOf(".");
        // 少于2位小数 补0
        if(indexPoint == -1 || lengthFee - indexPoint < 3) {
            feeShow = fee.toFixed(2);
        }
        // console.log(fee + " => " + feeShow);
        return feeShow;
    }

    // 获取当前用户住院单
    $scope.getIPNotice = function () {
        $scope.initBaseDictCount++;
        $scope.isLoadingIpNoticeList = true;
        // HIS验证住院单信息
        IpRegService.getIPNotice().then(function (data) {
            $scope.initBaseDictCount--;
            $scope.isLoadingIpNoticeList = false;
            console.log(data);
            // 获取成功
            if (data.result == 1 || data.result == -1) {
                // 住院单列表不为空
                if (data.is_null == 0) {
                    // 格式化数据
                    data.data.forEach(e => {
                        // 拟入院日期
                        e.ADMISSION_DATE = e.ADMISSION_DATE.length == 0 ? "" : new Date(e.ADMISSION_DATE).Format("yyyy年M月d日");
                        // 预交押金
                        e.PREPAID_PAYMENT = $scope.formatFee(Number(e.PREPAID_PAYMENT));
                    });
                    $scope.ipNoticeList = data.data;
                }
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        }, function (data) {
            $scope.initBaseDictCount--;
            $scope.isLoadingIpNoticeList = false;
            console.log(data);
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        });
    }

    // 获取当前用户住院单V2
    $scope.getIPNoticeV2 = function () {
        $scope.initBaseDictCount++;
        $scope.isLoadingIpNoticeList = true;
        // HIS验证住院单信息
        IpRegService.getIPNoticeV2($scope.hisCardNum, $scope.ipNoticeId).then(function (data) {
            $scope.initBaseDictCount--;
            $scope.isLoadingIpNoticeList = false;
            console.log(data);
            // 获取成功
            if (data.result == 1 || data.result == -1) {
                // 住院单列表不为空
                if (data.is_null == 0) {
                    // 格式化数据
                    data.data.forEach(e => {
                        // 拟入院日期
                        e.ADMISSION_DATE = e.ADMISSION_DATE.length == 0 ? "" : new Date(e.ADMISSION_DATE).Format("yyyy年M月d日");
                        // 预交押金
                        e.PREPAID_PAYMENT = $scope.formatFee(Number(e.PREPAID_PAYMENT));
                    });
                    $scope.ipNoticeList = data.data;
                }
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
            $scope.nextSlide();
        }, function (data) {
            $scope.initBaseDictCount--;
            $scope.isLoadingIpNoticeList = false;
            console.log(data);
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        });
    }

    // 获取基础字典
    $scope.getBaseDict = function (type) {
        if ($scope.baseDictTypeList.indexOf(type) == -1) {
            return;
        }
        IpRegService.getDict(type, "").then(function (data) {
            $scope.initBaseDictCount--;
            // 获取成功
            if (data.result == 1) {
                if (type == "AREA") {
                    $scope.dict["prvn"] = data.data;
                }
                else {
                    $scope.dict[type.toLowerCase()] = data.data;
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
            // 并发最后一个回来的取消loading
            if ($scope.initBaseDictCount == 0) {
                $ionicLoading.hide();
            }
        })
    }

    // 2021-4-14 14:32:19 检查拟入院日期、床位类型服务状态
    $scope.checkDateBedServerStatus = function () {
        IpRegService.checkDateBedServerStatus().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 住院登记填写拟入院日期、床位类型开关
                if (devMode || data.data) {
                    $scope.funcSwitch.ipRegDateBedServerStatus = true;
                }
            }
            // 获取失败
            else {
                //$fwCordovaToast.showLongBottom(data.msg);
            }
        })
    }

    // 2021-5-4 20:38:15 显示入院须知
    $scope.showIpRegNotice = function () {
        ;
    }
    // 入院须知模态窗口显示
    $scope.ipRegNoticeShow = function () {
        event.stopPropagation();
        $scope.ipRegNoticeModal.show();
    }
    // 入院须知模态窗口隐藏
    $scope.ipRegNoticeHide = function () {
        $scope.ipRegNoticeModal.hide();
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideIpReg.enableSlide(false);
    });

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $rootScope.goBack();
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'ipReg');
        $ionicLoading.show();
        // 获取用户须知信息
        IpRegService.agreement().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                $scope.agreement.ipRegDescription = data.data;
                // 2021-5-4 20:55:17 入院须知
                $scope.agreement.ipRegNotice = data.ipRegNotice;
            }
            // 查询失败
            else {
                $fwCordovaToast.showLongBottom(data.msg);
            }
        })
        if($scope.from == "qrcode"){
            $scope.getIPNoticeV2();
        } else {
            // 加载就诊人列表
            $scope.loadVpList();
            // 获取当前用户住院单
            $scope.getIPNotice();
        }
        // 获取基础字典
        for (var type in $scope.baseDictTypeList) {
            $scope.initBaseDictCount++;
            $scope.getBaseDict($scope.baseDictTypeList[type]);
        }
        // 2021-4-14 14:32:19 检查拟入院日期、床位类型服务状态
        $scope.checkDateBedServerStatus();
    })

    // 页面退出，解除后退绑定
    // 可能绑定的事件得改
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'ipReg') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    })
    //#endregion
})
