﻿angular.module('fwapp.controllers')

.controller('MessageController', function ($scope, $rootScope, $state, $ionicPlatform, $ionicLoading, $ionicViewSwitcher, $ionicScrollDelegate, PersonalService) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 消息列表
    $scope.messageList = [];
    // 当前页
    $scope.pageNum = 1;
    // 是否可继续加载
    $scope.canLoadMore = false;
    // 是否加载完毕
    $scope.isLoadFinish = false;
    // 搜索消息中心
    $scope.inputType = "";

    // 加载数据
    $scope.loadList = function () {
        if ($scope.inputType != "") {
            $scope.pageNum = 1;
            $scope.messageList = [];
        }

        PersonalService.messageList($scope.pageNum, $scope.inputType).then(function (data) {
            for (var i = 0; i < data.msgList.length; i++) {
                $scope.messageList.push(data.msgList[i]);
            }
            if ($scope.inputType != "") {
                $ionicScrollDelegate.scrollTop();
                if (data.msgList.length == 0) {
                    $fwCordovaToast.showShortBottom("未找到指定消息");
                }
            }
            $scope.canLoadMore = (data.pageNum - 1) * data.pageSize + data.msgList.length < data.totalCount;
            $scope.pageNum++;
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.$broadcast('scroll.refreshComplete');

            $scope.isLoadFinish = true;
        });
    }

    // 滚动条用，用于控制是否可继续延迟加载
    $scope.moreDataCanBeLoaded = function () {
        return $scope.isLoadFinish && $scope.canLoadMore;
        console.log($scope.isLoadFinish && $scope.canLoadMore);
    }

    // 2020-2-21 08:28:33 无脑返回首页 避免死循环
    $scope.goBack = function () {
        $ionicViewSwitcher.nextDirection('back');
        //$state.go('app.home');
        $rootScope.goBack();
    }

    // 页面进入，绑定后退事件
    $scope.$on('$ionicView.enter', function () {
        if (!$rootScope.checkLogin()) {
            return;
        }
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'message');

        $ionicLoading.show();
        $scope.loadList();

        // 消息提示
        PersonalService.lastMsg(localStorage["lastMsgId_" + localStorage.currentAccountId]).then(function (data) {
            localStorage["lastMsgId_" + localStorage.currentAccountId] = data.lastMsgDate;
            $rootScope.hasUnread = false;
            $rootScope.unReadCount = 0;
            $ionicLoading.hide();
        })
    });

    // 页面退出，解除后退绑定
    $scope.$on('$ionicView.beforeLeave', function () {
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'message') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });

    // 2018-6-28 14:48:35 点击消息跳转
    $scope.goState = function (state, params) {
        //console.log(state);
        //console.log(params);
        if (state == null || state == "") {
            return;
        }
        $state.go(state, params);
    }
})