﻿angular.module('fwapp.controllers')

// 视频问诊
.controller('OlTreatVideoController', function ($scope, $rootScope, $state, $stateParams, $interval, $timeout, $http
, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $ionicScrollDelegate, $ionicLoading, $ionicPlatform, $ionicActionSheet
, $cordovaCamera, $cordovaImagePicker, $cordovaFileTransfer, $cordovaGeolocation, $cordovaInAppBrowser, $fwCordovaToast, $filter
, ConsultationService, RequestService, OlTreatRecipeService, ExpressService) {

    // 如果没登录 扔出去
    if (localStorage.currentAccountId.length == 0) {
        $state.go("login");
        return;
    }

    // 定义视频问诊滑块
    var slideOlTreatVideo = $ionicSlideBoxDelegate.$getByHandle('slideOlTreatVideo');
    // 初始滑块状态
    $scope.step = -1;
    // 传进来的applyId
    $scope.applyId = $stateParams.treatApplyId;
    // 传进来的vpId
    $scope.vpId = $stateParams.vpId;
    // 支付页面对象
    $scope.payData = {};
    // 倒计时
    $scope.payTimeLeftVideo = 0;
    // 是否加载完成
    $scope.isLoadFinish = false;
    // 定时器关闭
    $scope.timerStop = false;
    // 会话列表
    $scope.chatList = [];
    // 药品快递到家同意须知
    $scope.expressStatement = new Object();
    $scope.expressStatement.agree = false;
    $scope.expressStatement.content = "";
    $scope.expressStatement.title = "";
    // 图文上传信息
    $scope.imgServerUrl = uploadUrl;
    // 图像容器总高度
    $scope.imgBoxTotalHeight = $(window).height() - ($rootScope.currentPlatform == "iOS" ? 42 : 22);
    // 快递信息
    $scope.orderRoute = new Object();

    // #region 滑动方法

    // 滑到上一步
    $scope.lastSlide = function () {
        slideOlTreatVideo.previous();
        $scope.step = slideOlTreatVideo.currentIndex();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideOlTreatVideo.next();
        $scope.step = slideOlTreatVideo.currentIndex();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideOlTreatVideo.slide(index);
        $scope.step = slideOlTreatVideo.currentIndex();
        console.log("toSlide =>" + index);
    }

    // #endregion

    // #region 模态框相关

    // 注册模态窗口 查看病情描述
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('infomation.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.infomationModal = modal;
    });

    // 注册模态窗口 免责声明
    $ionicModal.fromTemplateUrl('statement.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.statementModal = modal;
    });

    // 注册模态窗口:门诊病历
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('check_result.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.checkResultModal = modal;
    });

    // 注册模态窗口：查询快递信息
    $ionicModal.fromTemplateUrl('templates/expressInfo.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.expressInfoModal = modal;
    });

    // 销毁模态窗口
    $scope.$on('$destroy', function () {
        $scope.infomationModal.remove();
        $scope.statementModal.remove();
        $scope.checkResultModal.remove();
        $scope.expressInfoModal.remove();
    })

    // 病情描述模态框展示
    $scope.infomationModalShow = function () {
        $scope.infomationModal.show();
    }

    // 病情描述模态框隐藏
    $scope.infomationModalHide = function () {
        $scope.infomationModal.hide();
    }

    // 免责声明模态框展示
    $scope.statementModalShow = function () {
        $scope.statementModal.show();
    }

    // 免责声明模态框隐藏
    $scope.statementModalHide = function () {
        $scope.statementModal.hide();
    }

    // 门诊病历显示
    $scope.checkResultShow = function () {
        $scope.checkResultModal.show();
    }

    // 门诊病历隐藏
    $scope.checkResultHide = function () {
        $scope.checkResultModal.hide();
    }

    // 查询快递信息窗口显示
    $scope.expressInfoShow = function () {
        $scope.expressInfoModal.show();
    }

    // 查询快递信息窗口关闭
    $scope.expressInfoHide = function () {
        $scope.expressInfoModal.hide();
    }

    // #endregion

    // 1.加载页面
    $scope.loadTreatApply = function () {
        $ionicLoading.show();
        $scope.isLoadFinish = false;
        ConsultationService.loadTreatApply($scope.applyId, $scope.vpId).then(function (data) {
            $scope.isLoadFinish = true;
            $ionicLoading.hide();
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else {
                $scope.payData = data.data;
                $scope.toSlide(0);
                // 未支付
                if ($scope.payData.payStatus == 0) {
                    // 获取支付时间限制
                    $scope.getTimeLimit();
                }
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请稍后重试",
                okText: "确定"
            });
        })
    }
    // #region 待支付及倒计时工具类
    // 获取支付时间限制
    $scope.getTimeLimit = function () {
        ConsultationService.getTimeLimitVideo($scope.applyId).then(function (data) {
            console.log(data);
            // 获取成功
            if (data.result == 1) {
                $rootScope.payTimeLeftOlTreatVideo = data.data;
                if ($rootScope.payStatusOlTreatVideo != 1) {
                    $rootScope.payStatusOlTreatVideo = 1;
                }
                // 倒计时
                $scope.timerStop = true;
                $scope.timeCountdown();
            }
            else {
                $scope.timerStop = false;
                $rootScope.payStatusOlTreatVideo = 0;
                $rootScope.payTimeLeftOlTreatVideo = 0;
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请稍后重试",
                okText: "确定"
            });
        })
    }

    // 倒计时
    $scope.timeCountdown = function () {
        if (!$scope.$$phase) {
            $scope.$apply($rootScope.payTimeLeftOlTreatVideo = $rootScope.payTimeLeftOlTreatVideo - 1);
        } else {
            $rootScope.payTimeLeftOlTreatVideo = $rootScope.payTimeLeftOlTreatVideo - 1;
        }
        clearTimeout($rootScope.payResendTimeerOlTreatVideo);
        if ($rootScope.payTimeLeftOlTreatVideo > 0) {
            $rootScope.payResendTimeerOlTreatVideo = setTimeout($scope.timeCountdown, 1000);
        }
        else {
            if (!$scope.$$phase) {
                $scope.$apply($rootScope.payStatusOlTreatVideo = 0);
            } else {
                $rootScope.payStatusOlTreatVideo = 0;
            }
        }
    }

    // #endregion

    // 1.1取消
    $scope.cancelApply = function () {
        $ionicLoading.show();
        ConsultationService.overTimeVideoApply($scope.applyId, $scope.vpId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else if (data.result == 99) {
                $ionicPopup.alert({
                    title: '提示',
                    template: "网络超时，请重试",
                    okText: "确定"
                });
            }
            else {
                $fwCordovaToast.showShortBottom("取消成功");
                // 重新获取时间
                $scope.getTimeLimit();

                // 不管是退钱，还是不退钱，都直接goback
                $scope.goBack();
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络失败，请稍后再试",
                okText: "确定"
            });
        })
    }

    // 2.手动取消
    $scope.cancelVideoApply = function () {
        $ionicPopup.confirm({
            title: "提示",
            template: "是否确认取消预约？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $scope.cancelApply();
            }
        })
    }

    // 3.立即支付
    $scope.unifiedOrder = function () {
        // 医保患者
        if ($scope.payData.miPatient == 1) {
            // 如果走完医保分割了，这里直接缴费就行了
            if ($scope.payData.fundPay != null && $scope.payData.cashPay != null && $scope.payData.personCountPay != null) {
                // 收银台
                $scope.cashier("olTreat", $scope.payData.cashPay, $scope.vpId, $scope.applyId, "", "", $scope.payData.doctorCode, true, $scope.payData.fundPay, $scope.payData.personCountPay, $scope.payData.treatFeeNum).then(function (dataCashier) {
                    // 支付成功 获取订单状态
                    if (dataCashier.code == 1) {
                        // 等待支付轮询结果
                        $scope.respApplyVideo($scope.applyId);
                        // 重新获取支付时间
                        $scope.getTimeLimit();
                    }
                })
            }
            else {
                $ionicLoading.show();
                // 走医保分割
                RequestService.miPreDivideRevisit($scope.vpId, $scope.payData.doctorCode).then(function (dataMI) {
                    // 轮询结束
                    if (dataMI.result == 1) {
                        // 不为空，是有值得
                        if (dataMI.is_null == 0) {
                            // 回写三个值
                            OlTreatRecipeService.miPreResultApply($scope.applyId, dataMI.data[0].CASH_PAY, dataMI.data[0].FUND_PAY, dataMI.data[0].PERSON_COUNT_PAY).then(function (dataMIApply) {
                                $ionicLoading.hide();
                                if (dataMIApply.result == 1) {
                                    // 收银台
                                    $scope.cashier("olTreat", dataMI.data[0].CASH_PAY, $scope.vpId, $scope.applyId, "", "", $scope.payData.doctorCode, true, dataMI.data[0].FUND_PAY, dataMI.data[0].PERSON_COUNT_PAY, $scope.payData.treatFeeNum).then(function (dataCashier) {
                                        // 支付成功 获取订单状态
                                        if (dataCashier.code == 1) {
                                            // 等待支付轮询结果
                                            $scope.respApplyVideo($scope.applyId);
                                            // 重新获取支付时间
                                            $scope.getTimeLimit();
                                        }
                                        else {
                                            // 重新加载当前页面
                                            $scope.loadTreatApply();
                                        }
                                    })
                                }
                                else {
                                    $ionicPopup.alert({
                                        title: '提示',
                                        template: dataMIApply.msg,
                                        okText: "确定"
                                    });
                                }
                            }, function (dataMIApply) {
                                $ionicLoading.hide();
                                $ionicPopup.alert({
                                    title: '提示',
                                    template: dataMIApply.msg,
                                    okText: "确定"
                                });
                            })
                        }
                        else {
                            $ionicLoading.hide();
                            $ionicPopup.alert({
                                title: '提示',
                                template: dataMI.msg,
                                okText: "确定"
                            });
                        }
                    }
                    else {
                        $ionicLoading.hide();
                        $ionicPopup.alert({
                            title: '提示',
                            template: "服务繁忙，请稍后重试",
                            okText: "确定"
                        });
                    }
                }, function (dataMI) {
                    $ionicLoading.hide();
                    $ionicPopup.alert({
                        title: '提示',
                        template: "网络错误，医保金额拆分失败，请稍后重试",
                        okText: "确定"
                    });
                })
            }
        }
        // 自费患者
        else {
            $scope.cashier("olTreat", $scope.payData.treatFeeNum, $scope.vpId, $scope.applyId, "", "", $scope.payData.doctorCode, false, "", "", $scope.payData.treatFeeNum).then(function (dataCashier) {
                // 支付成功 获取订单状态
                if (dataCashier.code == 1) {
                    // 等待支付轮询结果
                    $scope.respApplyVideo($scope.applyId);
                    // 重新获取支付时间
                    $scope.getTimeLimit();
                }
            })
        }
    }

    // 3.1验证支付状态，视频问诊
    $scope.respApplyVideo = function (applyId) {
        $ionicLoading.show();
        // 等待支付轮询结果
        OlTreatRecipeService.getSubmitApply(applyId).then(function (dataResp) {
            $ionicLoading.hide();
            //轮询成功
            if (dataResp.result == 1) {
                // 轮询成功
                if (dataResp.applyResult == 1) {
                    // 重新刷新页面
                    $scope.loadTreatApply();
                }
                else {
                    $ionicPopup.alert({
                        title: '提示',
                        template: dataResp.msg,
                        okText: "确定"
                    });
                }
            }
            else if (dataResp.result == 99) {
                $ionicPopup.alert({
                    title: '提示',
                    template: "服务繁忙，请稍后重试",
                    okText: "确定"
                });
            }
            // 获取失败
            else {
                $ionicPopup.alert({
                    title: '提示',
                    template: dataResp.msg,
                    okText: "确定"
                });
            }
        }, function (dataResp) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: dataResp.msg,
                okText: "确定"
            });
        })
    }

    // 4.退号操作
    $scope.signOutVideoApply = function () {
        $ionicPopup.confirm({
            title: "提示",
            template: "当前操作不可逆，是否确认退号？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                // 退号，退费
                $scope.cancelApply();
            }
        })
    }

    // 5.视频问诊签到
    $scope.videoSignIn = function () {
        $ionicLoading.show();
        ConsultationService.videoSignIn($scope.vpId, $scope.applyId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else if (data.result == 99) {
                $ionicPopup.alert({
                    title: '提示',
                    template: "网络不佳，请重新进行签到",
                    okText: "确定"
                });
            }
            else {
                // 这里成功，可以用toast
                $fwCordovaToast.showShortBottom("签到成功");
                $scope.loadTreatApply();
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请重试",
                okText: "确定"
            });
        })
    }

    // 6.进入房间
    $scope.videoGetIntoRoom = function () {
        $ionicLoading.show();
        ConsultationService.videoGetIntoRoom($scope.vpId, $scope.applyId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else {
                // 进入视频
                var param = { roomId: data.data.ROOM_ID, applyId: data.data.TREAT_APPLY_ID, userId: $scope.vpId };

                var funcSuccess = function (data) {
                    console.log("MiniProgramPlugin：launchMiniProgram 调用成功");
                    console.log(data);
                }
                var funcError = function (data) {
                    console.log("MiniProgramPlugin：launchMiniProgram 调用失败");
                    console.log(data);
                }

                window.plugins.MiniProgramPlugin.launchMiniProgram(param, funcSuccess, funcError);
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请重试",
                okText: "确定"
            });
        })
    }

    // 7.查看诊疗资料
    $scope.treatApplyVdieoDetail = function (isSlide) {
        $scope.chatList = [];
        $ionicLoading.show();
        ConsultationService.getTreatApplyVideoConvr($scope.applyId).then(function (data) {
            $ionicLoading.hide();
            console.log(data);
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else {
                $scope.chatList = data.data;
                if (isSlide == true) {
                    // 跳转到下一页
                    $scope.toSlide(1);
                }
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请重试",
                okText: "确定"
            });
        })
    }

    // 8.查看病情描述
    $scope.goInfomation = function () {
        var isSubmit = true;
        var schedDate = new Date($scope.payData.dateSched);
        var nowDate = new Date();
        if (nowDate.getTime() - schedDate.getTime() > 0) {
            isSubmit = false;
        }
        console.log(isSubmit);
        var data = {
            "infomationId": $scope.payData.infomationId,
            "vpId": $scope.vpId,
            "doctorCode": $scope.payData.doctorCode,
            "isSubmit": isSubmit
        };

        $scope.infomationModalShow();
        $scope.$broadcast("infomationShow", data);
    }

    // 8.1接收病情描述返回
    $scope.$on('infomationHide', function (event, data) {
        $scope.infomationModalHide();
        if (data.type == "submit") {
            console.log("成功了");
        }
    })

    // 9.知情同意
    $scope.toExpress = function () {

        var html = "<p>请您认真阅读并同意<span style='color:blue;text-decoration:underline;' ng-click='statementShow()'><<" + $scope.expressStatement.title + ">></span><p>";

        $scope.popupConfirm = $ionicPopup.confirm({
            title: "提示",
            template: html,
            buttons: [
                {
                    text: "不同意",
                    onTap: function (e) { }
                },
                {
                    text: "同意",
                    type: "button-positive",
                    onTap: function (e) {
                        $scope.submitApply();
                    }
                }
            ],
            scope: $scope
        });
    }

    // 9.1展示须知内容
    $scope.statementShow = function () {
        $scope.popupConfirm.close();
        $scope.statementModalShow();
    }

    // 10.提交开药申请
    $scope.submitApply = function () {
        $ionicLoading.show();
        ConsultationService.confirmVideoMedWay($scope.applyId, $scope.vpId).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 0) {
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
            }
            else {
                // 跳转到快递到家模块
                $state.go("app.express", { applyId: $scope.applyId });
            }
        }, function () {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请稍后重试",
                okText: "确定"
            });
        })
    }

    // 11.检查缴费
    $scope.toOpPayment = function (rlatObjId) {
        // 跳转至门诊缴费
        $state.go("app.opPayment", { status: "0", vpid: $scope.vpId, from: "app.olTreatVideo", rlatObjId: rlatObjId });
    }

    // 12.查看门诊病历
    $scope.toOpRecord = function (idr) {
        $scope.queryPassword().then(function (data) {
            if (data) {
                $scope.toOpRecordReq(idr);
            }
        })
    }

    // 12.1创建手势控件
    // 创建图片手势控件
    $scope.createPinchZoom = function () {
        $timeout(function () {
            var src = $("#imgCheckResultOrigin").prop("src");
            // 防止赋值不同步
            if (src == "") {
                $timeout(function () {
                    // 创建图片手势控件
                    $scope.createPinchZoom();
                }, 0);
                return;
            }
            // 无图片
            if ($("#imgCheckResult").length != 1) {
                return;
            }
            // 初始化
            if ($("#divCheckResult>#imgCheckResult").length == 0) {
                // 还原节点位置
                $("#divCheckResult").append($("#imgCheckResult"));
                // 删除控件
                //$("#divCheckResult .pinch-zoom-container").remove();
                // 插件没有destory方法 控件删除会报错 暂时扔到隐藏的div里
                $("#divTrash").append($("#divCheckResult .pinch-zoom-container"));
            }
            // 复制图片路径
            $("#imgCheckResult").prop("src", src);
            // 计算最大放大倍数 图片实际尺寸/屏幕尺寸
            var img = document.querySelector("#imgCheckResult");
            var zoomOptions = {};
            var zoomBase = Math.max(img.naturalWidth / img.width, img.naturalHeight / img.height);
            if (zoomBase > 4) {
                zoomOptions.maxZoom = zoomBase;
                zoomOptions.tapZoomFactor = zoomBase / 2;
            }
            $scope.imgCheckResult = new PinchZoom.default(img, zoomOptions);
            $scope.imgCheckResult.enable();
            console.log($scope.imgCheckResult);
        }, 0);
    }

    // 12.2查看门诊病历，走request
    $scope.toOpRecordReq = function (idr){
        // 走request
        $ionicLoading.show();
        RequestService.getNuClearList($scope.vpId, idr, "MZBL", localStorage.queryToken).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $ionicPopup.alert({
                    title: '提示',
                    template: "连接超时，请稍后重试",
                    okText: "确定"
                });
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.toOpRecordReq(idr);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }

            $scope.checkResult = {
                INDEX: 0,
                REPORT_IMAGE: ''
            }
            // 清空图片
            $("#imgCheckResult").prop("src", "");
            // 释放内存
            delete $scope.imgCheckResult;
            $scope.imgCheckResult = {};

            // 有结果 显示base64图片
            $scope.checkResult.TITLE = "互联网门诊病历";
            $scope.checkResult.INDEX = 0;
            $scope.checkResult.REPORT_IMAGE = "data:image/png;base64," + data.data;
            // 创建图片手势控件
            $scope.createPinchZoom();

            // 打开模态框
            $scope.checkResultShow();
        }, function (err) {
            $ionicLoading.hide();
            $ionicPopup.alert({
                title: '提示',
                template: "网络错误，请稍后重试",
                okText: "确定"
            });
        })
    }

    // 13.查看物流信息
    $scope.toExpressInfo = function () {
        $ionicLoading.show();
        ExpressService.getOrderRoute($scope.applyId).then(function (data){
            $ionicLoading.hide();
            if(data.result == 1){
                $scope.orderRoute = data.data.Result;
                $scope.expressInfoShow();
            }
            else{
                $fwCordovaToast.showShortBottom("暂无快递信息");
            }
        }, function (err) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("获取物流信息，网络错误。");
        })
    }

    // 14.查看处方信息（带签名）
    $scope.toDrugRecord = function () {
        $ionicLoading.show();
        OlTreatRecipeService.getDrugRecord($scope.vpId, $scope.applyId).then(function (data){
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $ionicPopup.alert({
                    title: '提示',
                    template: "连接超时，请稍后重试",
                    okText: "确定"
                });
                return;
            }

            if (data.result != 1 && data.result != -1) {  // 请求错误
                $ionicPopup.alert({
                    title: '提示',
                    template: data.msg,
                    okText: "确定"
                });
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }

            $scope.checkResult = {
                INDEX: 0,
                REPORT_IMAGE: ''
            }
            // 清空图片
            $("#imgCheckResult").prop("src", "");
            // 释放内存
            delete $scope.imgCheckResult;
            $scope.imgCheckResult = {};

            // 有结果 显示base64图片
            $scope.checkResult.TITLE = "互联网门诊处方";
            $scope.checkResult.INDEX = 0;
            $scope.checkResult.REPORT_IMAGE = "data:image/png;base64," + data.data;
            // 创建图片手势控件
            $scope.createPinchZoom();

            // 打开模态框
            $scope.checkResultShow();
        }, function (err) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("查看处方信息，网络错误。");
        })
    }

    // 15.入院登记
    $scope.toIpReg = function () {
        $state.go("app.ipReg");
    }

    // 返回
    $scope.goBack = function () {
        if ($scope.step == 1) {
            $scope.toSlide(0);
        }
        else {
            $state.go("app.consultationList", { treatType: "2" });
        }
    }

    // 页面切换
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
        //$fwCordovaToast.showShortBottom("step: " + $scope.step);
    }

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideOlTreatVideo.enableSlide(false);
    });

    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
            e.preventDefault();
            return false;
        }, 135, 'olTreatVideo');

        // 获取配置
        OlTreatRecipeService.getConfig().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                // 2020-4-24 16:12:50 HM 增加药品快递到家免责申明
                $scope.expressStatement.content = data.data.expressStatementContent;
                $scope.expressStatement.title = data.data.expressStatementTitle;

                $scope.loadTreatApply();
            }
            // 查询失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
                $ionicLoading.hide();
            }
        })
    });

    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        for (actionId in $ionicPlatform.$backButtonActions) {
            if ($ionicPlatform.$backButtonActions[actionId].id == 'olTreatVideo') {
                $ionicPlatform.$backButtonActions[actionId].priority = 0;
            }
        }
    });
})
