﻿angular.module('fwapp.controllers')

.controller('ReportController', function ($scope, $rootScope, $state, $stateParams, $window, $timeout,
    $ionicPopup, $ionicModal, $ionicLoading, $ionicPopover, $ionicScrollDelegate, $ionicSlideBoxDelegate, $ionicPlatform, $ionicHistory, $cordovaInAppBrowser,
    ReportService, AccountService, VisitPatientService, RequestService, ChangePhoneNumberService, $fwCordovaToast) {
    // 检查登录状态
    $rootScope.checkLogin();

    // 定义检验查询滑块
    var slideReport = $ionicSlideBoxDelegate.$getByHandle('slideReport');
    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideReport.enableSlide(false);
    });

    // 初始滑块状态
    $scope.step = 0;
    // 标题数组
    // 2021-4-29 20:40:22 应对4s评审 报告查询模块包含了门诊病历住院病历 改名为诊疗资料
    //$scope.titleList = ['报告查询', '化验单', '检查报告', '门诊病历', '住院列表', '住院病历'];
    $scope.titleList = ['诊疗资料', '化验单', '检查报告', '门诊病历', '住院列表', '住院病历'];

    // 就诊人ID
    $scope.vpId = $stateParams.vpid;
    // 就诊人信息
    $scope.vpInfo = new Object();
    // 就诊人列表
    $scope.vpList = [];

    // 是否加载完成
    $scope.isLoadFinish = false;
    // 2021-11-5 19:19:12 检验结果仅显示异常
    $scope.screenFlag = true;
    $scope.showAvailable = false;
    // 防止多次下一步
    $scope.disableVerify = false;
    // 图片验证码
    $scope.imageVericode = {};
    $scope.imageVericode.status = 0;
    $scope.imageVericode.src = {};
    // 防止多次获取验证码
    $scope.disableGetVericode = false;
    //手机验证后直接进入
    $scope.thisResultIndex = 0;
    $scope.thisResultFunc = "";
    //手机验证成功的ID
    $scope.authId = "";
    //下载验证成功的ID
    $scope.downloadId = "";
    // LIS列表
    $scope.lisList = [];
    // 当前检验类型
    $scope.lisType = 1;
    // LIS结果
    $scope.lisResult = {
        INDEX: 0,
        TEST_ORDER_NAME: '',
        SAMPLING_TIME: '',
        SAMPLE_CLASS_NAME: '',
        LIS_RESULT: []
    }
    $scope.timespan = 0;
    $scope.reqId = '';
    $scope.watermark = {};

    // 检查列表
    $scope.checkList = [];
    // 当前检查项目类型  2020-11-27 LBZ 增加注释 查阅后发现，此类型非彼类型，而是检查可查的日期段
    $scope.checkType = 1;
    // 检查结果
    $scope.checkResult = {
        INDEX: 0,
        REPORT_IMAGE: '',
        TITLE: "检查报告"
    }
    // 检查报告图像
    $scope.imgCheckResult = {};
    // 图像容器总高度
    $scope.imgBoxTotalHeight = $(window).height() - ($rootScope.currentPlatform == "iOS" ? 42 : 22);

    // 核医学科检查列表 来源于自助机
    $scope.nuclearList = [];
    // 当前核医学科项目类型  2020-11-27 LBZ 增加注释 查阅后发现，此类型非彼类型，而是检查可查的日期段
    $scope.nuclearType = 1;
    // 检查结果
    $scope.nuclearResult = {
        INDEX: 0,
        REPORT_IMAGE: ''
    }

    // 检查影像 门诊病历 住院病历 开关
    $scope.checkReportImageServerStatus = devMode ? true : false;
    $scope.opRecordServerStatus = devMode ? true : false;
    $scope.ipRecordServerStatus = devMode ? true : false;

    // 验卡模型
    $scope.vpVerify = {
        phone_num: '',
        phone_num_show: '',
        imageVericode: '',
        messageVericode: ''
    };

    // 检查报告图像
    $scope.imgUnclearResult = {};

    // 门诊病历
    $scope.opRecordList = [];
    // 当前门诊病历类型
    $scope.opRecordType = 1;

    // 住院列表
    $scope.ipList = [];
    // 当前住院病历类型
    $scope.ipType = 1;

    // 住院病历列表
    $scope.ipRecordList = [];
    // 住院病历需要的参数
    $scope.record_type = "";
    $scope.record_oldnew = "";

    // 注册弹出菜单：就诊人列表
    $ionicPopover.fromTemplateUrl('pop_vplist.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.popVplist = popover;
    });

    // 注册模态窗口:LIS结果
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('lis_result.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.lisResultModal = modal;
    });

    // 注册模态窗口:检查结果
    $ionicModal.fromTemplateUrl($rootScope.getElderlyUrl('check_result.html'), {
        scope: $scope
    }).then(function (modal) {
        $scope.checkResultModal = modal;
    });

    // 注册模态窗口:验证手机号
    $ionicModal.fromTemplateUrl('verifyPhone.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.vpVerify.imageVericode = "";
        $scope.vpVerify.messageVericode = "";
        $scope.getImageVericode();
        $scope.verifyPhoneModal = modal;
    });

    // 隐藏模态窗口:验证手机号
    $scope.verifyPhoneModalHide = function () {
        // 隐藏
        $scope.verifyPhoneModal.hide();
    }

    // 注销模态窗口
    $scope.$on('$destroy', function () {
        $scope.lisResultModal.remove();
        $scope.checkResultModal.remove();
        $scope.verifyPhoneModal.remove();
    });

    // 显示弹出菜单
    $scope.openPopoverVpList = function ($event) {
        $scope.popVplist.show($event);
    }

    // 滑到指定页
    $scope.toSlide = function (index) {
        // 验证查询密码
        $scope.queryPassword().then(function (data) {
            if (data) {
                // 验证门诊/住院病历开关
                if (index == 3 && !$scope.opRecordServerStatus) {
                    $fwCordovaToast.showShortBottom("门诊病历查询功能正在维护中，请稍后再试");
                    return;
                }
                if (index == 4 && !$scope.ipRecordServerStatus) {
                    $fwCordovaToast.showShortBottom("住院病历查询功能正在维护中，请稍后再试");
                    return;
                }
                slideReport.slide(index);
                $scope.step = slideReport.currentIndex();
                if ($scope.step == 1) {
                    // 2021-11-23 19:31:35 HM 适老化看全部
                    console.log("看下适老化变量:" + $rootScope.elderly);
                    if ($rootScope.elderly == true || $rootScope.elderly == "true") {
                        $scope.changeLisType(0);
                    }
                    else {
                        $scope.loadLisList(1);
                    }
                }
                if ($scope.step == 2) {
                    if ($rootScope.elderly == true || $rootScope.elderly == "true") {
                        $scope.changeCheckType(0);
                    }
                    else {
                        $scope.loadCheckList(1);
                    }
                }
                // 2021-4-18 11:22:07 HM 发现核医学没有入口，暂时先屏蔽掉吧，这个3我用了
                if ($scope.step == 3) {
                    // $scope.loadNuClearList(1);
                    // 门诊病历查询
                    if ($rootScope.elderly == true || $rootScope.elderly == "true") {
                        $scope.changeOpRecordType(0);
                    }
                    else {
                        $scope.loadOpRecordList(1);
                    }
                }
                if ($scope.step == 4) {
                    // 住院病历查询
                    if ($rootScope.elderly == true || $rootScope.elderly == "true") {
                        $scope.changeIpType(0);
                    }
                    else {
                        $scope.loadIpList(1);
                    }
                }
            }
        })
    }

    // 后退 重写goBack
    $scope.goBack = function () {
        // 第0页（选择lis/check）正常后退
        if ($scope.step == 0) {
            if ($stateParams.vpid == "") {
                //$scope.toggleSlideMenu();
                $rootScope.goBack();
            }
            else {
                $state.go('app.visitPatient', { vpid: $scope.vpId });
            }
        }
        else if ($scope.step == 5){
            // 如果是住院病历列表，返回到住院列表
            $scope.toSlide(4);
        }
        // 其他页返回第一个滑块
        else {
            slideReport.slide(0);
            $scope.step = slideReport.currentIndex();
        }
    }

    // 仅显示异常
    $scope.screen = function () {
        $scope.screenFlag = !$scope.screenFlag;
        $scope.showAvailable = !$scope.showAvailable;
        $ionicScrollDelegate.resize();
        $ionicScrollDelegate.scrollTop();
    }

    // 读取就诊人信息
    $scope.loadVPInfo = function () {
        VisitPatientService.visitPatientInfo($scope.vpId).then(function (data) {
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            } else {
                $scope.vpInfo = data.data;
            }
        })
    }

    //#region 列表加载

    // 读取LIS列表
    $scope.loadLisList = function (type) {
        $scope.screenFlag = true;
        $scope.showAvailable = false;
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        $scope.lisList = [];

        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        RequestService.lisList($scope.vpId, type, localStorage.queryToken).then(function (data) {
            // 无效QueryToken
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadLisList(type);
                    }
                })
                return;
            }
            // 链接超时
            if (data.result == 99) {
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 缓存
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING
                $timeout(function () {
                    if (data.is_null != 1) { // 空结果
                        $scope.lisList = data.data;
                    }
                    loadFinish();
                }, 1500);
                return;
            }

            if (data.is_null != 1) { // 空结果
                $scope.lisList = data.data;
            }
            // 非缓存
            loadFinish()
        });
    }

    // 读取检查列表
    $scope.loadCheckList = function (type) {
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        $scope.checkList = [];

        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        RequestService.checkList($scope.vpId, type, localStorage.queryToken).then(function (data) {
            // 无效Token
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadCheckList(type);
                    }
                })
                return;
            }
            // 链接超时
            if (data.result == 99) {
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 非缓存
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING
                $timeout(function () {
                    if (data.is_null != 1) {
                        $scope.checkList = data.data;
                    }
                    loadFinish();
                }, 1500);
                return;
            }
            // 正常请求
            if (data.is_null != 1) {
                $scope.checkList = data.data;
            }
            loadFinish();
        });
    }

    // 获取核医学科检查列表
    $scope.loadNuClearList = function (type){
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        $scope.nuclearList = [];

        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        RequestService.unClearList($scope.vpId, type, localStorage.queryToken, "HYXBG").then(function (data) {
            console.log(data);

            // 无效Token
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadNuClearList(type);
                    }
                })
                return;
            }
            // 链接超时
            if (data.result == 99) {
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 非缓存
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING
                $timeout(function () {
                    if (data.is_null != 1) {
                        $scope.nuclearList = data.data;
                    }
                    loadFinish();
                }, 1500);
                return;
            }
            // 正常请求
            if (data.is_null != 1) {
                $scope.nuclearList = data.data;
            }
            loadFinish();
        });
    }

    // 获取门诊病历列表
    $scope.loadOpRecordList = function (type){
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        $scope.opRecordList = [];

        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        RequestService.opRecordList($scope.vpId, type, localStorage.queryToken).then(function (data){
            // 无效QueryToken
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadOpRecordList(type);
                    }
                })
                return;
            }
            // 链接超时
            if (data.result == 99) {
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 缓存
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING
                $timeout(function () {
                    if (data.is_null != 1) { // 空结果
                        $scope.opRecordList = data.data;
                    }
                    loadFinish();
                }, 1500);
                return;
            }
            if (data.is_null != 1) { // 空结果
                $scope.opRecordList = data.data;
            }
            // 非缓存
            loadFinish();
        });
    }

    // 获取住院病历列表
    $scope.loadIpList = function (type){
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        $scope.ipList = [];
        $scope.ipType = type;

        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();

        RequestService.ipList($scope.vpId, type, localStorage.queryToken).then(function (data){
            // 无效QueryToken
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadIpList(type);
                    }
                })
                return;
            }
            // 链接超时
            if (data.result == 99) {
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 缓存
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING
                $timeout(function () {
                    if (data.is_null != 1) { // 空结果
                        $scope.ipList = data.data;
                    }
                    loadFinish();
                }, 1500);
                return;
            }
            if (data.is_null != 1) { // 空结果
                $scope.ipList = data.data;
            }
            // 非缓存
            loadFinish();
        })
    }

    // 获取住院病历列表
    $scope.ipRecordListShow = function (index){
        $ionicLoading.show();
        $scope.ipRecordList = [];

        $scope.record_type = $scope.ipList[index].CG;
        $scope.record_oldnew = $scope.ipList[index].BRXT;
        RequestService.ipRecordList($scope.vpId, $scope.ipList[index].IDB, $scope.ipList[index].CG, localStorage.queryToken).then(function (data){
            console.log(data);
            // 无效QueryToken
            if (data.result == -2) {
                $ionicLoading.hide();
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.ipRecordListShow(index);
                    }
                })
                return;
            }
            // 链接超时
            if (data.result == 99) {
                loadFinish();
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                loadFinish();
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 缓存
            if (data.result == -1) {
                // 延迟1秒隐藏LOADING
                $timeout(function () {
                    if (data.is_null != 1) { // 有结果
                        $scope.ipRecordList = data.data;
                        $scope.toSlide(5);
                    }
                    $ionicLoading.hide();
                }, 1500);
                return;
            }
            if (data.is_null != 1) { // 有结果
                $scope.ipRecordList = data.data;
                $scope.toSlide(5);
            }
            else{
                $fwCordovaToast.showShortBottom("当病历不支持查看");
            }

            // 非缓存
            $ionicLoading.hide();
        });
    }

    function loadFinish() {
        $ionicLoading.hide();
        $scope.isLoadFinish = true;
    }

    //#endregion

    //#region LIS结果查看

    // 查看LIS结果
    $scope.lisResultShow = function (index) {
        $scope.thisResultIndex = index;
        $scope.thisResultFunc = "lis";
        if ($scope.vpInfo.IS_SELF == 1) {
            $scope.getLisInfo(index);
            $scope.lisResultModal.show();
            AccountService.getWatermark().then(function (data) {
                $scope.watermark = data.data;
            });
        }
        else {
            //验证身份及授权
            ReportService.verify($scope.vpId).then(function(data) {
                //已验证过
                if (data.result == 1) {
                    $scope.getLisInfo(index);
                    $scope.lisResultModal.show();
                    AccountService.getWatermark().then(function (data) {
                        $scope.watermark = data.data;
                    });
                }
                else if(data.result == 0) {//没验证
                    $scope.verifyPhoneModal.show();
                    $scope.GetReservedPhone();
                }
                else {
                    $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                    return;
                }
            }, function() {
                $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                return;
            })
        }
    }

    // 关闭LIS结果查看
    $scope.lisResultHide = function () {
        $scope.lisResultModal.hide();
        $scope.lisResult = {
            INDEX: 0,
            TEST_ORDER_NAME: '',
            SAMPLING_TIME: '',
            SAMPLE_CLASS_NAME: '',
            LIS_RESULT: []
        }
    }

    // 获取LIS检验结果
    $scope.getLisInfo = function (index) {
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        var lis = $scope.lisList[index];
        RequestService.lisResult($scope.vpId, lis.INSPECTION_ID, localStorage.queryToken).then(function (data) {
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.loadLisList(index);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            $scope.reqId = data.data[0].REQUEST_ID;
            $scope.lisResult.INDEX = index;
            $scope.lisResult.TEST_ORDER_NAME = lis.TEST_ORDER_NAME;
            $scope.lisResult.SAMPLING_TIME = lis.SAMPLING_TIME;
            $scope.lisResult.SAMPLE_CLASS_NAME = lis.SAMPLE_CLASS_NAME;
            $scope.lisResult.LIS_RESULT = data.data;
            loadFinish();
        });
    }

    //#endregion

    // #region 病历详情

    // 获取住院病历详情
    $scope.ipRecordDetail = function (index){
        $ionicLoading.show();
        $scope.checkResult = {
            INDEX: 0,
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};

        RequestService.ipRecordDetail($scope.vpId, $scope.ipRecordList[index].IDR, $scope.ipRecordList[index].IDB, $scope.record_type, $scope.record_oldnew, localStorage.queryToken).then(function (data){
            console.log(data);
            $ionicLoading.hide();

            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.ipRecordDetail(index);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showShortBottom("当前病历不支持查看");
                return;
            }
            // 有结果 显示base64图片
            $scope.checkResult.INDEX = index;
            $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + data.data;
            // 创建图片手势控件
            $scope.createPinchZoom();
            $scope.checkResult.TITLE = "病历详情";
            $scope.checkResultModal.show();
        })
    }

    // 获取门诊病历详情
    $scope.opRecordResult = function (index) {
        $ionicLoading.show();
        $scope.checkResult = {
            INDEX: 0,
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};

        RequestService.opRecordDetail($scope.vpId, $scope.opRecordList[index].IDB_ASC, $scope.opRecordList[index].IDR_ASC, $scope.opRecordList[index].LB, $scope.opRecordList[index].KH_ASC, $scope.opRecordList[index].BAH, $scope.opRecordList[index].IDT_ASC, $scope.opRecordList[index].FILEPATH_ASC, localStorage.queryToken).then(function (data){
            console.log(data);
            $ionicLoading.hide();

            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.opRecordResult(index);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                $fwCordovaToast.showShortBottom("当前病历不支持查看");
                return;
            }
            // 有结果 显示base64图片
            $scope.checkResult.INDEX = index;
            $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + data.data;
            // 创建图片手势控件
            $scope.createPinchZoom();
            $scope.checkResult.TITLE = "病历详情";
            $scope.checkResultModal.show();
        })
    }

    // #endregion

    //#region

    // 查看自助机检查结果
    $scope.nuclearResultShow = function (index) {
        $scope.checkResult = {
            INDEX: 0,
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};
//        if ($scope.unclearList[index].CHECK_STATUS == '0') {
//            $fwCordovaToast.showShortBottom("该核医学检查未出报告，请耐心等待");
//            return false;
//        }
        if ($scope.vpInfo.IS_SELF != 1) {
            $fwCordovaToast.showShortBottom("仅允许关系为本人的就诊人查看核医学检查结果");
            return false;
        }
        $scope.getUnclearInfo(index);
        $scope.checkResultModal.show();
    }

    // 获取核医学检查报告图片
    $scope.getUnclearInfo = function (index) {
        $ionicLoading.show();
        var check = $scope.nuclearList[index];
        RequestService.unClearResult($scope.vpId, check.SQDBH, localStorage.queryToken, "HYXBG").then(function (data) {
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.getCheckInfo(index);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            // 有结果 显示base64图片
            $scope.checkResult.INDEX = index;
            $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + data.data;
            // 创建图片手势控件
            $scope.createPinchZoom();
            $scope.checkResult.TITLE = "检查报告";
        }, function (err) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("连接超时，请重试");
        });
    }

    //#endregion

    //#region 检查结果查看

    // 查看检查结果
    $scope.checkResultShow = function (index) {
        $scope.thisResultIndex = index;
        $scope.thisResultFunc = "check";
        $scope.checkResult = {
            INDEX: 0,
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};
        if ($scope.checkList[index].CHECK_STATUS == '0') {
            $fwCordovaToast.showShortBottom("该检查未出报告，请耐心等待");
            return false;
        }
        if ($scope.vpInfo.IS_SELF == 1) {
            $scope.checkResult.TITLE = "检查报告";
            $scope.getCheckInfo(index);
            $scope.checkResultModal.show();
        }
        else {
            //验证身份及授权
            ReportService.verify($scope.vpId).then(function(data) {
                //已验证过
                if(data.result == 1) {
                    $scope.checkResult.TITLE = "检查报告";
                    $scope.getCheckInfo(index);
                    $scope.checkResultModal.show();
                } else if(data.result == 0) {
                    $scope.verifyPhoneModal.show();
                    $scope.GetReservedPhone();
                } else {
                    $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                    return;
                }
            },function() {
                $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                return;
            })
        }
    }

    // 关闭检查结果
    $scope.checkResultHide = function () {
        $scope.checkResultModal.hide();
        $scope.checkResult = {
            INDEX: 0,
            REPORT_IMAGE: ''
        }
        // 清空图片
        $("#imgCheckResult").prop("src", "");
        // 释放内存
        delete $scope.imgCheckResult;
        $scope.imgCheckResult = {};
    }

    // 创建图片手势控件
    $scope.createPinchZoom = function () {
        $timeout(function () {
            var src = $("#imgCheckResultOrigin").prop("src");
            // 防止赋值不同步
            if (src == "") {
                $timeout(function () {
                    // 创建图片手势控件
                    $scope.createPinchZoom();
                }, 0);
                return;
            }
            // 无图片
            if ($("#imgCheckResult").length != 1) {
                return;
            }
            // 初始化
            if ($("#divCheckResult>#imgCheckResult").length == 0) {
                // 还原节点位置
                $("#divCheckResult").append($("#imgCheckResult"));
                // 删除控件
                //$("#divCheckResult .pinch-zoom-container").remove();
                // 插件没有destory方法 控件删除会报错 暂时扔到隐藏的div里
                $("#divTrash").append($("#divCheckResult .pinch-zoom-container"));
            }
            // 复制图片路径
            $("#imgCheckResult").prop("src", src);
            // 计算最大放大倍数 图片实际尺寸/屏幕尺寸
            var img = document.querySelector("#imgCheckResult");
            var zoomOptions = {};
            var zoomBase = Math.max(img.naturalWidth / img.width, img.naturalHeight / img.height);
            if (zoomBase > 4) {
                zoomOptions.maxZoom = zoomBase;
                zoomOptions.tapZoomFactor = zoomBase / 2;
            }
            $scope.imgCheckResult = new PinchZoom.default(img, zoomOptions);
            $scope.imgCheckResult.enable();
            console.log($scope.imgCheckResult);
        }, 0);
    }

    // 获取检查报告图片
    $scope.getCheckInfo = function (index) {
        $ionicLoading.show();
        var check = $scope.checkList[index];
        RequestService.checkResult($scope.vpId, check.ID, check.TYPE, localStorage.queryToken).then(function (data) {
            $ionicLoading.hide();
            $scope.reqId = data.reqId;
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.getCheckInfo(index);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            // 有结果 显示base64图片
            $scope.checkResult.INDEX = index;
            $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + data.data;
            // 创建图片手势控件
            $scope.createPinchZoom();
        }, function (err) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("连接超时，请重试");
        });
    }

    //#endregion

    // #region 检查影像查询

    // 获取检查影响详情
    $scope.checkResultImgShow = function (index){
        $ionicPopup.confirm({
            title: "提示",
            template: "调取影像报告资料，需等待1-2分钟，确认申请查看么？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if(res){
                $scope.checkResult = {
                    INDEX: 0,
                    REPORT_IMAGE: ''
                }
                // 清空图片
                $("#imgCheckResult").prop("src", "");
                // 释放内存
                delete $scope.imgCheckResult;
                $scope.imgCheckResult = {};

                if ($scope.checkList[index].CHECK_STATUS == '0') {
                    $fwCordovaToast.showShortBottom("该检查未出报告，请耐心等待");
                    return false;
                }
                if ($scope.vpInfo.IS_SELF != 1) {
                    $fwCordovaToast.showShortBottom("仅允许关系为本人的就诊人查看检查结果");
                    return false;
                }

                $scope.checkResult.TITLE = "检查影像";
                $scope.getCheckImgInfo(index);
                $scope.checkResultModal.show();
            }
        })
    }

    // 获取检查影像图片
    $scope.getCheckImgInfo = function (index) {
        $ionicLoading.show();
        var check = $scope.checkList[index];
        RequestService.checkResultImg($scope.vpId, check.ID, localStorage.queryToken).then(function (data){
            $ionicLoading.hide();
            if (data.result == 99) {    // 链接超时
                $fwCordovaToast.showShortBottom("连接超时，请重试");
                return;
            }
            if (data.result == -2) {
                $scope.queryPassword().then(function (data) {
                    if (data) {
                        $scope.getCheckImgInfo(index);
                    }
                })
                return;
            }
            if (data.result != 1 && data.result != -1) {  // 请求错误
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            if (data.is_null == 1) { // 空结果
                return;
            }
            // 有结果 显示base64图片
            $scope.checkResult.INDEX = index;
            $scope.checkResult.REPORT_IMAGE = "data:image/jpeg;base64," + data.data;
            // 创建图片手势控件
            $scope.createPinchZoom();
        }, function (err) {
            $ionicLoading.hide();
            $fwCordovaToast.showShortBottom("连接超时，请重试");
        })
    }

    // #endregion

    // #region 检查报告下载

    //下载PDF
    $scope.downloadPDF = function (reqId,index) {
        $scope.isLoadFinish = false;
        $ionicLoading.show();
        if (reqId != null && reqId.length > 0) {
            ReportService.saveDownloadRecord($scope.vpId,$scope.thisResultFunc,reqId,
                $scope.thisResultFunc=="lis"?$scope.lisList[index].TEST_ORDER_NAME:$scope.checkList[index].DESCRIPTION,"PDF",
                $scope.thisResultFunc=="lis"?$scope.lisList[index].INSPECTION_ID:$scope.checkList[index].ID).then(function(data) {
                  $scope.downloadId = data.downloadId;
                  RequestService.downloadPDF(reqId, $scope.vpId).then(function(dataPdf) {
                      if (dataPdf.result == 1) {
                          ReportService.changeDownloadStatus($scope.vpId, $scope.downloadId, 1);
                          var option = {
                              location: 'yes',
                              clearcache: 'no',
                              toolbar: 'yes'
                          }
                          var url = dataPdf.data;
                          $cordovaInAppBrowser.open(url, '_system', '').then(function (event) {});
                          loadFinish();
                          return;
                      }
                      // 链接超时
                      else if (dataPdf.result == 99) {
                          ReportService.changeDownloadStatus($scope.vpId,$scope.downloadId,2);
                          loadFinish();
                          $fwCordovaToast.showShortBottom("连接超时，请重试");
                          return;
                      }
                      else {
                          ReportService.changeDownloadStatus($scope.vpId,$scope.downloadId,2);
                          loadFinish();
                          $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                          return;
                      }
                  }, function(errPdf) {
                      $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                      console.log(errPdf);
                  });
              }, function(err) {
                  $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                  console.log(err);
              });
        }
        else {
            loadFinish();
            $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
            return;
        }
    }

    // #endregion

    // #region 非本人授权浏览

    // 获取预留手机号
    $scope.GetReservedPhone = function () {
        $ionicLoading.show();
        RequestService.GetReservedPhone($scope.vpId).then(function (data) {
            // 圈消失
            $ionicLoading.hide();
            // 链接超时
            if (data.result == 99) {
                $fwCordovaToast.showShortBottom('获取预留手机号失败，服务繁忙，请重试');
                return;
            }
            // 请求错误
            if (data.result != 1 && data.result != -1) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            // 空结果
            if (data.is_null == 1) {
                $fwCordovaToast.showShortBottom(data.msg);
                return;
            }
            var phone = data.data[0].PHONENUM;
            $scope.vpVerify.phone_num = phone;
            $scope.vpVerify.phone_num_show = phone.toString().substring(0, 3) + "****" + phone.toString().substring(7, phone.toString().length);
        });
    }

    //获取短信验证码
    $scope.verifyToGetMsgVericode = function () {
        // 验证图片验证码
        if ($scope.vpVerify.imageVericode == null || $scope.vpVerify.imageVericode.length == 0) {
            var alertPopup = $ionicPopup.alert({
                title: '验证失败',
                template: '图片验证码不得为空'
            });
            return;
        }
        AccountService.sendVericodeByPhone($scope.vpVerify.phone_num, "10", $scope.vpVerify.imageVericode,$scope.vpId,$scope.thisResultFunc).then(function (data) {
            $ionicLoading.hide();
            // 发送成功
            if (data.result == 1){
                //记录验证信息
                ReportService.saveVerifyInfo($scope.vpId,$scope.thisResultFunc).then(function(data){
                    if(data.result == 1){
                        $scope.authId = data.authId;
                        $scope.disableGetVericode = true;
                        $fwCordovaToast.showShortBottom("已向您的预留手机发送验证码，请填写验证码完成绑定");
                        // 倒计时
                        $scope.timespan = 60;
                        TimeCount();
                    }else{
                        $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                        return;
                    }
                })
            }else if (data.result == 0) {// 服务调用失败
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg
                });
            }else {
                // 刷新图片验证码
                $scope.getImageVericode();
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: '获取验证码失败，请稍后重试'
                });
            }
            $scope.disableGetVericode = false;
        },function(){
            $scope.disableGetVericode = false;
        });
    }

    //验证手机验证码
    $scope.verifyCardSubmit = function () {
        if ($scope.vpVerify.phone_num == '' || $scope.vpVerify.messageVericode == '') {
            $fwCordovaToast.showShortBottom('请完整填写预留手机验证信息');
            return false;
        }
        $scope.disableVerify = true;
        ChangePhoneNumberService.compareVericode($scope.vpVerify.phone_num, $scope.vpVerify.messageVericode, currentPlatform, deviceToken, "10").then(function (data) {
            if (data.result == 1) {
                $scope.timespan = 0; //倒计时清零
                $fwCordovaToast.showShortBottom("验证成功。");
                //记录验证信息
                ReportService.updateVerifyInfo($scope.vpId,$scope.authId).then(function(data){
                    if(data.result == 1){
                        $scope.verifyPhoneModal.hide();
                        if($scope.thisResultFunc == "check"){
                            $scope.checkResult.TITLE = "检查报告";
                            $scope.getCheckInfo($scope.thisResultIndex);
                            $scope.checkResultModal.show();
                        }else if($scope.thisResultFunc == "lis"){
                            $scope.getLisInfo($scope.thisResultIndex);
                            $scope.lisResultModal.show();
                            AccountService.getWatermark().then(function (data) {
                                $scope.watermark = data.data;
                            });
                        }
                    }else{
                        $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                        $scope.disableVerify = false;
                        return;
                    }
                }, function () {
                    $fwCordovaToast.showShortBottom("当前请求失败，请稍后再试");
                    $scope.disableVerify = false;
                    return;
                })
            }else {
                $scope.getImageVericode();
                $scope.vpVerify.imageVericode = "";
                $scope.vpVerify.messageVericode = "";
                var alertPopup = $ionicPopup.alert({
                    title: '验证失败',
                    template: data.msg
                });
            }
            $scope.disableVerify = false;
        }, function (data) {
            $scope.disableVerify = false;
        })
    }

    // 获取图片验证码
    $scope.getImageVericode = function () {
        AccountService.getImageVericode().then(function (data) {
            // 需要验证码
            if (data.result == 1) {
                $scope.imageVericode.src = "data:image/jpeg;base64," + data.data;
            }
            // 不需要验证码
            else {
                $scope.imageVericode.src = "";
            }
            $scope.imageVericode.status = data.result;
            $scope.vpVerify.imageVericode = "";
        }, function (data) {
            // 获取失败 显示 点击重新获取
            $scope.imageVericode.status = 1;
        });
    }

    // 重新发送倒计时
    function TimeCount() {
        if (!$scope.$$phase) {
            $scope.$apply($scope.timespan = $scope.timespan - 1);
        } else {
            $scope.timespan = $scope.timespan - 1;
        }
        resendTimeer = setTimeout(TimeCount, 1000);
        if ($scope.timespan <= 0) {
            clearTimeout(resendTimeer);
            $scope.disableGetVericode = false;
        }
    };

    // #endregion

    // 切换就诊人
    $scope.changeVp = function (vpid) {
        $scope.vpId = vpid;
        $scope.vpInfo = new Object();
        $scope.loadVPInfo();
        $scope.loadLisList($scope.lisType);
        $scope.loadCheckList($scope.checkType);
        // $scope.loadNuClearList($scope.nuclearType);
        $scope.loadOpRecordList($scope.opRecordType);
        $scope.loadIpList($scope.ipType);
        $scope.popVplist.hide();

        if($scope.step == 5){
            $scope.toSlide(4);
        }
    }

    // 切换LIS类型
    $scope.changeLisType = function (type) {
        $scope.lisType = type;
        $scope.loadLisList(type);
    }

    // 切换检查类型
    $scope.changeCheckType = function (type) {
        $scope.checkType = type;
        $scope.loadCheckList(type);
    }

    // 切换核医学科报告类型
    $scope.changeUnclearType = function (type) {
        $scope.nuclearType = type;
        $scope.loadNuClearList(type);
    }

    // 切换门诊病历类型
    $scope.changeOpRecordType = function (type){
        $scope.opRecordType = type;
        $scope.loadOpRecordList(type);
    }

    // 切换住院病历类型
    $scope.changeIpType = function (type){
        $scope.ipType = type;
        $scope.loadIpList(type);
    }

    // 滑块切换触发
    $scope.slideChanged = function () {
        // 返回清空数据
        $scope.isLoadFinish = false;

        $scope.lisList = [];
        $scope.lisType = 1;

        $scope.checkList = [];
        $scope.checkType = 1;

        $scope.nuclearList = [];
        $scope.nuclearType = 1;

        $scope.opRecordList = [];
        $scope.opRecordType = 1;

        $scope.ipList = [];
        $scope.ipType = 1;

        // 重新计算滚动条高度
        $ionicScrollDelegate.resize();
        $ionicScrollDelegate.scrollTop();
    }

    // 页面进入
    $scope.$on('$ionicView.enter', function () {
        // 绑定返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            if ($scope.step == 0) {
                $ionicHistory.clearHistory();
                $state.go('app.home');
                //console.warn('清空历史测试');
            }
            else {
                $scope.goBack();
            }
            e.preventDefault();
            return false;
        }, 135, 'report');

        // 获取配置
        ReportService.getConfig().then(function (data) {
            // 查询成功
            if (data.result == 1) {
                // 2021-4-27 19:32:57 查询检查影像开关
                if (devMode || data.data.checkReportImageServerStatus) {
                    $scope.checkReportImageServerStatus = true;
                }
                // 2021-4-27 19:33:19 查询门诊病历开关
                if (devMode || data.data.opRecordServerStatus) {
                    $scope.opRecordServerStatus = true;
                }
                // 2021-4-27 19:34:02 查询住院病历开关
                if (devMode || data.data.ipRecordServerStatus) {
                    $scope.ipRecordServerStatus = true;
                }
            }
        })
    });

    // 初始化
    $scope.$on('$ionicView.loaded', function () {
        if (!$rootScope.checkLogin()) {
            return;
        }
        $scope.vpList = [];
        // 获取就诊人列表
        VisitPatientService.visitPatientList().then(function (data) {
            // 获取成功
            if (data.result == 1) {
                // 若无就诊人
                if (data.data.length == 0) {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("未找到绑定的就诊人信息");
                    return;
                }

                // 第一就诊人
                var vpid = "";
                for (var i = 0; i < data.data.length; i++) {
                    if (data.data[i].IS_BIND_CARD == '1') {
                        $scope.vpList.push(data.data[i]);
                        if (vpid == "") {
                            vpid = data.data[i].VISIT_PATIENT_ID;
                        }
                    }
                }

                // 若参数无就诊人信息
                if ($scope.vpId == "") {
                    // 默认第一就诊人
                    $scope.vpId = vpid;
                }

                // 若vpid仍为空
                if ($scope.vpId == "") {
                    $state.go("app.personal");
                    $fwCordovaToast.showShortBottom("请绑定就诊卡");
                    return;
                } else {
                    $scope.loadVPInfo();
                }
            }
            // 获取失败
            else {
                $fwCordovaToast.showShortBottom(data.msg);
            }
        })
    });

    // 页面离开
    $scope.$on('$ionicView.beforeLeave', function () {
        // 解除返回键绑定
        setTimeout(function () {
            for (actionId in $ionicPlatform.$backButtonActions) {
                if ($ionicPlatform.$backButtonActions[actionId].id == 'report') {
                    $ionicPlatform.$backButtonActions[actionId].priority = 0;
                }
            }
        }, 500);
    });
});