﻿angular.module('fwapp.controllers')

.controller('TemperatureController', function ($scope, $rootScope, $state, $http, $window, $ionicPopup, $ionicLoading, $ionicModal, $ionicScrollDelegate, $ionicPlatform, $ionicSlideBoxDelegate
, $cordovaAppVersion, $cordovaFileTransfer, $cordovaFileOpener2, $fwCordovaToast, $cordovaDatePicker, $timeout
, VisitPatientService, CasePrintService) {

    // 检查登录状态
    $rootScope.checkLogin();

    // 划块定义
    $scope.step = 0;
    // 定义滑块
    var slideTemperature = $ionicSlideBoxDelegate.$getByHandle('slideTemperature');
    // 流调问卷--患者列表
    $scope.epidSrvyPatientList = null;
    // 流调问卷--家属列表
    $scope.epidSrvyFamilyList = [];
    // 就诊人ID
    $scope.vp = {
        VISIT_PATIENT_ID: "",
        VISIT_PATIENT_NAME: "",
        IDCARD_CODE: ""
    };
    // 流调数据
    $scope.tempInfo = {
        VISIT_PATIENT_ID: "",
        PATIENT_TYPE: "",
        PATIENT_NAME: "",
        IDCARD_CODE: "",
        PHONENUM: "",
        PROVINCE: "",
        CITY: "",
        COUNTRY: "",
        ADDRESS: "",
        DATE_BACK: "",
        WAY_BACK: ""
    };
    // 流调选择
    $scope.tempSelect = [{ key: "是", value: "1" }, { key: "否", value: "0" }];
    // 提交方式
    $scope.tempSubmitWay = "";
    // 从哪来的
    $scope.from = "";
    // 返回的step
    $scope.stepBack = "";
    // 提交流调提示信息
    $scope.temperatureRemark = "";

    // #region 滑块相关

    // 滑块切换事件
    $scope.slideChanged = function () {
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // 滑到上一步
    $scope.lastSlide = function () {
        slideTemperature.previous();
        $scope.step = slideTemperature.currentIndex();
    }
    // 滑到下一步
    $scope.nextSlide = function () {
        slideTemperature.next();
        $scope.step = slideTemperature.currentIndex();
    }
    // 滑到指定页
    $scope.toSlide = function (index) {
        slideTemperature.slide(index);
        $scope.step = slideTemperature.currentIndex();
        // 进入预约列表 重新计算高度
        $ionicScrollDelegate.scrollTop();
        $ionicScrollDelegate.resize();
    }

    // #endregion

    // 1.先获取已填写的来院登记
    $scope.temperatureList = function () {
        // 先初始化变量
        $scope.vp.VISIT_PATIENT_NAME = "";
        $scope.vp.IDCARD_CODE = "";
        $scope.epidSrvyPatientList = null;
        $scope.epidSrvyFamilyList = [];

        // 先获取已填写的来院登记
        $ionicLoading.show();
        VisitPatientService.temperatureList($scope.vp.VISIT_PATIENT_ID).then(function (data) {
            console.log(data);
            $ionicLoading.hide();
            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                // 流调提交提示信息
                $scope.temperatureRemark = data.temperatureRemark;

                // 患者基本信息
                $scope.vp.VISIT_PATIENT_NAME = data.visitPatientDic.VISIT_PATIENT_NAME;
                $scope.vp.IDCARD_CODE = data.visitPatientDic.IDCARD_CODE;

                if (data.is_null == 1) {
                    // 是空的，没有历史数据
                    $scope.epidSrvyPatientList = null;
                    $scope.epidSrvyFamilyList = [];
                }
                else {
                    // 有填过的问卷
                    $scope.epidSrvyPatientList = JSON.stringify(data.patientDic) == "{}" ? null : data.patientDic;
                    $scope.epidSrvyFamilyList = data.familyDicList;
                }

                // 重新计算高度和置顶
                $ionicScrollDelegate.resize();
                $ionicScrollDelegate.scrollTop();
            }
        }, function (data) {
            $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
            $ionicLoading.hide();
        })
    }

    // 2.添加来院登记
    $scope.addTemp = function (type) {
        // 初始化填写信息
        $scope.tempInfo = {
            VISIT_PATIENT_ID: $scope.vp.VISIT_PATIENT_ID,
            PATIENT_TYPE: "",
            PATIENT_NAME: "",
            IDCARD_CODE: "",
            PHONENUM: "",
            PROVINCE: "",
            CITY: "",
            COUNTRY: "",
            ADDRESS: "",
            DATE_BACK: "",
            WAY_BACK: ""
        };

        if (type == 1) {
            // 初始化患者信息
            $scope.tempInfo.PATIENT_TYPE = 1;
            $scope.tempInfo.PATIENT_NAME = $scope.vp.VISIT_PATIENT_NAME;
            $scope.tempInfo.IDCARD_CODE = $scope.vp.IDCARD_CODE;
        }
        else {
            // 初始化家属信息
            $scope.tempInfo.PATIENT_TYPE = 2;
        }

        $scope.tempSubmitWay = "add";
        // 跳转第1页
        $scope.toSlide(1);
        // 重新计算高度和置顶
        $ionicScrollDelegate.resize();
        $ionicScrollDelegate.scrollTop();
    }

    // 3.提交流调
    $scope.temperatureSubmit = function () {
        // 判断必填项
        if ($scope.tempInfo.PATIENT_NAME == undefined || $scope.tempInfo.PATIENT_NAME == ""
            || $scope.tempInfo.IDCARD_CODE == undefined || $scope.tempInfo.IDCARD_CODE == ""
            || $scope.tempInfo.PHONENUM == undefined || $scope.tempInfo.PHONENUM == ""
            || $scope.tempInfo.IS_NOT_BACK == undefined
            || $scope.tempInfo.PROVINCE == undefined || $scope.tempInfo.PROVINCE == ""
            || $scope.tempInfo.CITY == undefined || $scope.tempInfo.CITY == ""
            || $scope.tempInfo.COUNTRY == undefined || $scope.tempInfo.COUNTRY == ""
            || $scope.tempInfo.ADDRESS == undefined || $scope.tempInfo.ADDRESS == ""
            || $scope.tempInfo.IS_TOUCH == undefined
            || $scope.tempInfo.IS_INFECT == undefined
            || $scope.tempInfo.IS_LIVE_HIGH_RISK == undefined
            || $scope.tempInfo.IS_EXIT_BORDER == undefined
            || $scope.tempInfo.IS_FEVER == undefined || $scope.tempInfo.IS_FEVER == ""
            || $scope.tempInfo.IS_CLOSE_CONTACTS == undefined || $scope.tempInfo.IS_CLOSE_CONTACTS == ""
            || $scope.tempInfo.IS_JOB_HIGH_RISK == undefined || $scope.tempInfo.IS_JOB_HIGH_RISK == ""
            || $scope.tempInfo.IS_FAMILY_UNSUAL == undefined || $scope.tempInfo.IS_FAMILY_UNSUAL == ""
            || $scope.tempInfo.IS_VACCINUM == undefined || $scope.tempInfo.IS_VACCINUM == ""
            || $scope.tempInfo.IS_AROUND_SYMPTOM == undefined || $scope.tempInfo.IS_AROUND_SYMPTOM == "") {

            $fwCordovaToast.showLongBottom("请完整填写就诊人及流调信息");
            return;
        }

        var reg = /^1[3-9][0-9]{9}$/;
        if (!reg.test($scope.tempInfo.PHONENUM)) {
            $fwCordovaToast.showLongBottom("请填写正确手机号码");
            return;
        }

        // 如果非常住北京，还需要验证进京时间和方式
        if ($scope.tempInfo.IS_NOT_BACK == 0) {
            if ($scope.tempInfo.DATE_BACK == undefined || $scope.tempInfo.DATE_BACK == ""
                || $scope.tempInfo.WAY_BACK == undefined || $scope.tempInfo.WAY_BACK == "") {

                $fwCordovaToast.showLongBottom("请完整填写就诊人信息");
                return;
            }
        }
        else {
            $scope.tempInfo.DATE_BACK = "";
            $scope.tempInfo.WAY_BACK = "";
        }

        $ionicLoading.show();
        VisitPatientService.epidemiolSrvySubmit($scope.tempInfo).then(function (result) {
            $ionicLoading.hide();
            if (result.result == 0) {
                $fwCordovaToast.showLongBottom(result.msg);
            }
            else {
                // 提交成功，返回第0页，重新刷新列表
                $scope.temperatureList();
                $scope.toSlide(0);
            }
        })
    }

    // 4.更新流调
    $scope.updateTemp = function (srvyId) {
        if (srvyId == "") {
            $fwCordovaToast.showLongBottom("暂时无法修改，请稍后重试");
            return;
        }
        $scope.tempInfo.PROVINCE = "";
        $scope.tempInfo.CITY = "";
        $scope.tempInfo.COUNTRY = "";

        $ionicLoading.show();
        VisitPatientService.getEpidemiolSrvy(srvyId).then(function (data) {
            $ionicLoading.hide();

            if (data.result == 0) {
                $fwCordovaToast.showShortBottom(data.msg);
            }
            else {
                $scope.tempInfo.EPIDEMIOL_SRVY_ID = data.data.EPIDEMIOL_SRVY_ID;
                $scope.tempInfo.VISIT_PATIENT_ID = data.data.VISIT_PATIENT_ID;
                $scope.tempInfo.PATIENT_NAME = data.data.PATIENT_NAME;
                $scope.tempInfo.IDCARD_CODE = data.data.IDCARD_CODE;
                $scope.tempInfo.ADDRESS = data.data.ADDRESS;
                $scope.tempInfo.DATE_BACK = data.data.DATE_BACK;
                $scope.tempInfo.WAY_BACK = data.data.WAY_BACK;
                $scope.tempInfo.IS_TOUCH = data.data.IS_TOUCH;
                $scope.tempInfo.IS_INFECT = data.data.IS_INFECT;
                $scope.tempInfo.IS_LIVE_HIGH_RISK = data.data.IS_LIVE_HIGH_RISK;
                $scope.tempInfo.IS_EXIT_BORDER = data.data.IS_EXIT_BORDER;
                $scope.tempInfo.PATIENT_TYPE = data.data.PATIENT_TYPE;
                $scope.tempInfo.PHONENUM = data.data.PHONENUM;
                $scope.tempInfo.IS_NOT_BACK = data.data.IS_NOT_BACK;
                $scope.tempInfo.IS_FEVER = data.data.IS_FEVER;
                $scope.tempInfo.IS_CLOSE_CONTACTS = data.data.IS_CLOSE_CONTACTS;
                $scope.tempInfo.IS_JOB_HIGH_RISK = data.data.IS_JOB_HIGH_RISK;
                $scope.tempInfo.IS_FAMILY_UNSUAL = data.data.IS_FAMILY_UNSUAL;
                $scope.tempInfo.IS_VACCINUM = data.data.IS_VACCINUM;
                $scope.tempInfo.IS_AROUND_SYMPTOM = data.data.IS_AROUND_SYMPTOM;

                // 省市县单独处理
                $scope.tempInfo.PROVINCE = "";
                $scope.tempInfo.CITY = "";
                $scope.tempInfo.COUNTRY = "";

                CasePrintService.getCity(data.data.PROVINCE).then(function (result) {
                    $scope.citys = result.citys;

                    CasePrintService.getCounty(data.data.CITY).then(function (dataCity) {
                        $scope.countrys = dataCity.countys;
                        // 无下级区县
                        if ($scope.countrys.length == 0) {
                            $scope.countrys = [];
                            $scope.countrys.push({ COUNTY: "无下级区/县" });
                        }

                        $timeout(function () {
                            $scope.tempInfo.PROVINCE = data.data.PROVINCE;
                            $scope.tempInfo.CITY = data.data.CITY;
                            $scope.tempInfo.COUNTRY = data.data.COUNTRY;
                        }, 500);

                        $scope.tempSubmitWay = "update";
                        $scope.toSlide(1);

                        $ionicScrollDelegate.resize();
                        $ionicScrollDelegate.scrollTop();
                    })
                })
            }
        }, function (data) {
            $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
            $ionicLoading.hide();
        })
    }

    // 5.删除流调
    $scope.delTemp = function (srvyId) {
        if (srvyId == "") {
            $fwCordovaToast.showLongBottom("暂时无法删除，请稍后重试");
            return;
        }

        var confirmPopup = $ionicPopup.confirm({
            title: '取消确认',
            template: "您确定要删除该患者家属信息吗？",
            cancelText: '取消',
            okText: '确定'
        }).then(function (res) {
            if (res) {
                $ionicLoading.show();
                VisitPatientService.deleteEpidemiolSrvy(srvyId).then(function (data) {
                    $ionicLoading.hide();
                    if (data.data == 0) {
                        $fwCordovaToast.showShortBottom(data.msg);
                    }
                    else {
                        $fwCordovaToast.showShortBottom("删除成功");
                        // 重新获取列表
                        $scope.temperatureList();
                    }
                }, function (data) {
                    $fwCordovaToast.showShortBottom("网络错误，请稍后重试");
                    $ionicLoading.hide();
                })
            }
        })
    }

    // 6.返回提交
    $scope.submitBack = function () {
        // 先判断是否填了患者
        if ($scope.epidSrvyPatientList == null) {
            $fwCordovaToast.showLongBottom("请填写患者来院登记信息");
            return;
        }

        // 没家属，提示他一下
        if ($scope.epidSrvyFamilyList.length == 0) {
            var confirmPopup = $ionicPopup.confirm({
                title: "提示",
                template: $scope.temperatureRemark,
                okText: '是',
                cancelText: '否'
            });
            // 继续, 跳转
            confirmPopup.then(function (res) {
                if (res) {
                    // 需要患者填写
                    return;
                }
                else {
                    // 返回提交
                    $scope.goBack('submit');
                }
            })
        }
        else {
            // 有家属，直接返回提交
            $scope.goBack('submit');
        }
    }

    // #region 辅助函数

    // 单选
    $scope.selectThis = function (type, value) {
        $scope.tempInfo[type] = value;
        $ionicScrollDelegate.resize();
    }

    // 2020-02-24 来院人员登记 省市县：省
    $scope.getProvince = function () {
        CasePrintService.getProvince().then(function (result) {
            $scope.provinces = result.provinces;
        })
    }

    // 省市县：市
    $scope.getCity = function () {
        $scope.tempInfo.CITY = "";
        $scope.tempInfo.COUNTRY = "";
        $scope.countrys = [];

        if ($scope.tempInfo.PROVINCE == "") {
            $scope.citys = [];
        }
        else {
            CasePrintService.getCity($scope.tempInfo.PROVINCE).then(function (result) {
                $scope.citys = result.citys;

                // 重新计算高度
                $ionicScrollDelegate.resize();
            })
        }
    }

    // 省市县：县
    $scope.getCountry = function () {
        $scope.tempInfo.COUNTRY = "";
        if ($scope.tempInfo.CITY == "") {
            $scope.countrys = [];
        }
        else {
            CasePrintService.getCounty($scope.tempInfo.CITY).then(function (result) {
                $scope.countrys = result.countys;

                // 无下级区县
                if ($scope.countrys.length == 0) {
                    $scope.countrys = [];
                    $scope.countrys.push({ COUNTY: "无下级区/县" });
                }

                // 重新计算高度
                $ionicScrollDelegate.resize();
            })
        }
    }

    // 日期控件的设置
    $scope.datePicker = function (target, type) {
        var value = eval("$scope." + target);
        var defaultDate = new Date();

        if (value != undefined && value != null && value != "") {
            // 处理iOS日期格式
            if (currentPlatform == "iOS") {
                value = value.replace(/-/g, "/");
            }
            defaultDate = new Date(value);

            if (isNaN(defaultDate.getDate())) {
                defaultDate = new Date("1970/01/02 " + value);
            }
        }
        var options = {
            mode: type,  	// "date" or "time" or "datetime"
            date: defaultDate,
            okText: "确定",
            cancelText: "取消",
            doneButtonLabel: "确定",
            cancelButtonLabel: "取消",
            is24Hour: true,
            androidTheme: 3,
            locale: "zh_cn"
        };

        $cordovaDatePicker.show(options).then(function (date) {
            if (typeof (date) != "undefined") {
                var resultDate = new Date(date)
                switch (type) {
                    case "date":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd');");
                        break;
                    case "time":
                        eval("$scope." + target + " = resultDate.Format('hh:mm');");
                        break;
                    case "datetime":
                        eval("$scope." + target + " = resultDate.Format('yyyy-MM-dd hh:mm:ss');");
                        break;
                }
            }
        });
    }

    // #endregion

    // 返回
    $scope.goBack = function (type) {
        if ($scope.step == 1) {
            $scope.toSlide(0);
        }
        else {
            var data = {
                step: $scope.stepBack,
                type: type
            };
            for (actionId in $ionicPlatform.$backButtonActions) {
                if ($ionicPlatform.$backButtonActions[actionId].id == 'temperatureBackbutton') {
                    $ionicPlatform.$backButtonActions[actionId].priority = 0;
                }
            }
            $scope.$emit("temperatureHide", data);
        }
    }

    // 由父级作用于传来的
    $scope.$on('temperatureShow', function (event, data) {
        // 初始化数据
        $scope.step = 0;
        $scope.provinces = [];
        $scope.citys = [];
        $scope.countrys = [];

        // 接收父级来的数据
        $scope.vp.VISIT_PATIENT_ID = data.vpId;
        $scope.from = data.from;
        $scope.stepBack = data.step;

        // 先获取来院登记列表
        $scope.temperatureList();
        // 获取省
        $scope.getProvince();
        // 2020-10-23 19:12:04 处理返回键事件
        $ionicPlatform.registerBackButtonAction(function (e) {
            $scope.goBack();
        }, 250, 'temperatureBackbutton');
    });

    // dom准备就绪
    ionic.DomUtil.ready(function () {
        // 禁用滑动
        slideTemperature.enableSlide(false);
    });
});